;;
;; Last updated: <2000/02/02 13:04:47 +0900>
;;

(provide "auto-time-stamp")

(in-package "editor")

(require "timestmp")

(export '(save-buffer-with-time-stamp time-stamp-toggle-active
	  *time-stamp-active* *time-stamp-start*
	  *time-stamp-end* *time-stamp-format*))

; non-nil Ȃ time-stamp s
(defvar *time-stamp-active* t)

; time-stamp OɃ}b`鐳K\
(defvar *time-stamp-start* "Last updated:[ \t]+[<\"]")

; time-stamp Ƀ}b`鐳K\
(defvar *time-stamp-end* "[>\"]")

; time-stamp ̃tH[}bg(ڍׂ format-date-string Q)
(defvar *time-stamp-format* "%Y/%m/%d %H:%M:%S %Z")

; time-stamp Lȍs
(defvar *time-stamp-line-limit* 30)

(defun time-stamp ()
  "time-stamp-start  time-stamp-end ̊ԂɌݎ}"
  (save-excursion
    (let (begin end limit)
      (goto-char (point-min))
      (save-excursion
	(forward-line *time-stamp-line-limit*)
	(setq limit (point)))
      (cond ((scan-buffer *time-stamp-start* :regexp t :tail t :limit limit)
	     (setq begin (point))
	     (save-excursion
	       (goto-eol)
	       (setq limit (point)))
	     (if (scan-buffer *time-stamp-end* :regexp t :limit limit)
		 (progn
		   (setq end (point))
		   (delete-region begin end)
		   (insert (format-date-string *time-stamp-format*)))
	       (message "Ȃ񂩃tH[}bgƂႤ?")))
	    (t
	     (message "ق܂Ƀ^CX^v?"))))))

(defun save-buffer-with-time-stamp ()
  "*time-stamp-active*  non-nil Ȃ (time-stamp) sĂ save-buffer"
  (interactive)
  (add-hook
   '*before-save-buffer-hook*
   'auto-time-stamp-hook-function)
  (when (buffer-modified-p)
    (save-buffer)))

(defun time-stamp-toggle-active (&optional arg)
  "*time-stamp-active* ̃gO"
  (interactive "*p")
  (setq *time-stamp-active*
	(cond ((null arg)
	       (not *time-stamp-active*))
	      (t
	       nil)))
  (message (concat "^CX^v"
		   (if *time-stamp-active*
		       ""
		     "ւ")
		   "D")))

(defun auto-time-stamp-hook-function ()
  (interactive)
  (and *time-stamp-active*
       (time-stamp))
  nil)

(add-hook
 '*before-save-buffer-hook*
 'auto-time-stamp-hook-function)
