;;; -*- Mode: Lisp; Package: OUTLINE-TREE2 -*-
;;; outline-tree.l

;; Copyright (C) 2001-2006 OHKUBO Hiroshi <ohkubo@s53.xrea.com>

;; Author: OHKUBO Hiroshi <ohkubo@s53.xrea.com>
;; Time-stamp: <2006/10/25 02:23:57 +0900>

;;; Commentary:

;; Description:
;;
;;  TreeView.dll pāAobt@Xg̃c[\Aobt@̃A
;;  EgC\s܂B
;;

;;; Code:

(provide "outline-tree/outline-tree")

(eval-when (:compile-toplevel :load-toplevel :execute)
  (require "treeview/setup"))

(require "outline-tree/defs")
(require "outline-tree/public-utils")
(require "outline-tree/utils")

(in-package "outline-tree2")

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; config t@C / autoload fBNg
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun outline-tree-create-base-directory ()
  (let ((dir *outline-tree-base-directory*))
    (unless (file-directory-p dir)
      (when (yes-or-no-p "fBNg ~A ݂܂B~%쐬܂H"  dir)
        (create-directory dir)))
    (file-directory-p dir)))

(defun outline-tree-check-autoload-directory ()
  (let ((dir *outline-tree-autoload-directory*))
    (unless (file-directory-p dir)
      (when (yes-or-no-p "fBNg ~A ݂܂B~%쐬܂H"  dir)
        (create-directory dir)))
    (file-directory-p dir)))

(let (loaded-p)
  (defun outline-tree-config-load ()
    "ݒt@Cǂݍ"
    (when *outline-tree-config-file*
      (let ((lc (concat *outline-tree-config-file* "c")))
        (cond
         ((and (file-exist-p lc) (not (file-directory-p lc)))
          (load lc)
          (setq loaded-p t))
         ((and (file-exist-p *outline-tree-config-file*)
               (not (file-directory-p *outline-tree-config-file*)))
          (load *outline-tree-config-file*)
          (setq loaded-p t))))))
  (defun outline-tree-config-loaded-p ()
    "ݒt@Cǂݍݍς"
    loaded-p))
(defun outline-tree-autoload ()
  (interactive)
  (unless (and (file-exist-p *outline-tree-autoload-directory*)
               (file-directory-p *outline-tree-autoload-directory*))
    (return-from outline-tree-autoload))
  (dolist (f (directory *outline-tree-autoload-directory*
                        :wild "*.l"
                        :absolute t
                        :file-only t
                        :recursive t))
    (let ((lc (concat f "c")))
      (if (file-exist-p lc)
          (load lc)
        (load f)))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; TREEVIEW Cup ()
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;----------------------------------------------------------------------------
;; TREEVIEW Cup {ϐ
;;----------------------------------------------------------------------------
(defvar *outline-tree-app-id* 'outline-tree)

(define-history-variable *outline-tree-use* nil
  "nil, t, :one-shot")
(define-history-variable *outline-tree-window-position* treeview:XPIS_LEFT)
(define-history-variable *outline-tree-window-width* 200)
(define-history-variable *outline-tree-window-height* 200)
(define-history-variable *outline-tree-window-display-style* nil)

(define-history-variable *outline-tree-font-facename-manual-p* nil)
(define-history-variable *outline-tree-font-facename* nil)
(define-history-variable *outline-tree-font-height-manual-p* nil)
(define-history-variable *outline-tree-font-height* nil)
(define-history-variable *outline-tree-font-bold* nil)
(define-history-variable *outline-tree-font-italic* nil)
(define-history-variable *outline-tree-font-underline* nil)

(define-history-variable *outline-tree-color-text-manual-p* nil)
(define-history-variable *outline-tree-color-text* nil)
(define-history-variable *outline-tree-color-bk-manual-p* nil)
(define-history-variable *outline-tree-color-bk* nil)

(define-history-variable *outline-tree-style-hasbuttons* t)
(define-history-variable *outline-tree-style-haslines* t)
(define-history-variable *outline-tree-style-linesatroot* nil)
(defvar *outline-tree-style-editlabels* :ignore)
(defvar *outline-tree-style-enabledragdrop* :ignore)
(defvar *outline-tree-style-showselalways* t)
(defvar *outline-tree-style-rtlreading* :ignore)
(define-history-variable *outline-tree-style-checkboxes* nil)
(define-history-variable *outline-tree-style-trackselect* nil)
(defvar *outline-tree-style-singleexpand* :ignore)
(defvar *outline-tree-style-infotip* nil)
(define-history-variable *outline-tree-style-fullrowselect* t)
(define-history-variable *outline-tree-style-tooltips* t)
(defvar *outline-tree-style-scroll* :ignore)
(defvar *outline-tree-style-nonevenheight* :ignore)
(defvar *outline-tree-style-hscroll* :ignore)

(define-history-variable *outline-tree-indent-manual-p* nil)
(define-history-variable *outline-tree-indent* nil)
(define-history-variable *outline-tree-item-height-manual-p* nil)
(define-history-variable *outline-tree-item-height* nil)

(define-history-variable *outline-tree-icon* t)
(define-history-variable *outline-tree-icon-directory*
  (merge-pathnames "site-lisp/outline-tree/icon/default" (si:system-root))
  "outline-tree: icon fBNg")

(define-history-variable *outline-tree-exclusive-open-group* nil)

(define-history-variable *outline-tree-treeview-recenter* nil "t, nil, :line")
(define-history-variable *outline-tree-treeview-recenter-line* 3)
(define-history-variable *outline-tree-treeview-scroll-margin* 3)

(defvar *outline-tree-map* nil)
(unless *outline-tree-map*
  (setq *outline-tree-map* (copy-keymap treeview::*treeview-map*))
  (define-key *outline-tree-map* #\TAB 'treeview::treeview-other-treeview-window)
  (define-key *outline-tree-map* #\C-g 'quit)
  (define-key *outline-tree-map* #\RET 'outline-tree-node-action)
  (define-key *outline-tree-map* #\Delete 'outline-tree-delete-outline-by-node)
  (define-key *outline-tree-map* #\C-p 'outline-tree-select-up-key-node)
  (define-key *outline-tree-map* #\C-n 'outline-tree-select-down-key-node)
  (define-key *outline-tree-map* #\C-b 'outline-tree-select-left-key-node)
  (define-key *outline-tree-map* #\C-f 'outline-tree-select-right-key-node)
  (define-key *outline-tree-map* #\C-z 'outline-tree-select-pageup-key-node)
  (define-key *outline-tree-map* #\C-v 'outline-tree-select-pagedown-key-node)
  (define-key *outline-tree-map* #\C-a 'outline-tree-select-ancestor-node)
  (define-key *outline-tree-map* #\C-e 'outline-tree-select-eldest-descendants-node)
  (define-key *outline-tree-map* #\C-s
              (treeview::treeview-make-tv-command outline-tree-isearch-forward))
  (define-key *outline-tree-map* #\C-r
              (treeview::treeview-make-tv-command outline-tree-isearch-backward))
  (define-key *outline-tree-map* #\P 'outline-tree-swap-region-by-prev-range-node)
  (define-key *outline-tree-map* #\N 'outline-tree-swap-region-by-next-range-node)
  (define-key *outline-tree-map* #\D 'outline-tree-delete-region-by-range-node))

(defvar *outline-tree-fix-map* nil
   "outline-tree: treeview keymap (ftHg΍)")
(unless *outline-tree-fix-map*
  ;; L[oChύXs
  (setq *outline-tree-fix-map* (copy-keymap treeview::*treeview-fix-map*))
  (define-key *outline-tree-fix-map* #\Up         'outline-tree-select-node-delay)
  (define-key *outline-tree-fix-map* #\Down       'outline-tree-select-node-delay)
  (define-key *outline-tree-fix-map* #\Left       'outline-tree-select-node-delay)
  (define-key *outline-tree-fix-map* #\Right      'outline-tree-select-node-delay)
  (define-key *outline-tree-fix-map* #\S-Up       'outline-tree-select-node-delay)
  (define-key *outline-tree-fix-map* #\S-Down     'outline-tree-select-node-delay)
  (define-key *outline-tree-fix-map* #\S-Left     'outline-tree-select-node-delay)
  (define-key *outline-tree-fix-map* #\S-Right    'outline-tree-select-node-delay)
  (define-key *outline-tree-fix-map* #\PageUp     'outline-tree-select-node-delay)
  (define-key *outline-tree-fix-map* #\PageDown   'outline-tree-select-node-delay)
  (define-key *outline-tree-fix-map* #\Home       'outline-tree-select-node-delay)
  (define-key *outline-tree-fix-map* #\End        'outline-tree-select-node-delay)
  (define-key *outline-tree-fix-map* #\S-PageUp   'outline-tree-select-node-delay)
  (define-key *outline-tree-fix-map* #\S-PageDown 'outline-tree-select-node-delay)
  (define-key *outline-tree-fix-map* #\S-Home     'outline-tree-select-node-delay)
  (define-key *outline-tree-fix-map* #\S-End      'outline-tree-select-node-delay))

;;----------------------------------------------------------------------------
;; TREEVIEW Cup ֐
;;----------------------------------------------------------------------------
(defun outline-tree-node-implicit-func-gen (&optional node)
  "outline-tree: ÖٓIɃm[hɑ΂čsp֐𐶐"
  (treeview::with-app (*outline-tree-app-id*)
    (unless node
      (setq node (outline-tree-get-selected-node)))
    (if (outline-tree-data-get-implicit-func node)
        (outline-tree-data-get-implicit-func node)
      (case (outline-tree-data-get-type node)
        (:buffer-node
         (when (outline-tree-chase-node-p)
           #'(lambda () (interactive)
               (outline-tree-set-buffer-by-node node))))
        (t
         (when (outline-tree-chase-node-p)
           (outline-tree-node-explicit-func-gen node)))))))

(defun outline-tree-node-explicit-func-gen (&optional node)
  "outline-tree: IɃm[hɑ΂čsp֐𐶐"
  (treeview::with-app (*outline-tree-app-id*)
    (unless node
      (setq node (outline-tree-get-selected-node)))
    (if (outline-tree-data-get-explicit-func node)
        (outline-tree-data-get-explicit-func node)
      (case (outline-tree-data-get-type node)
        (:category-node
         nil)
        (:folder-node
         nil)
        (:section-node
         (outline-tree-node-implicit-func-gen
          (outline-tree-get-buffer-node-by-node node)))
        (:info-node
         (treeview::with-app (*outline-tree-app-id*)
           (let ((parent-node (treeview::treeview-get-parent-item node)))
             (outline-tree-node-implicit-func-gen parent-node))))
        (:buffer-node
         (if (outline-tree-chase-node-p)
             #'(lambda () (interactive)
                 (outline-tree-create-outline-by-node node))
           #'(lambda () (interactive)
               (outline-tree-set-buffer-by-node node))))
        (:range-node
         #'(lambda () (interactive)
             (treeview::with-app (*outline-tree-app-id*)
               (let ((node node)
                     (whole-range (outline-tree-data-get-whole-range node))
                     (swindow (selected-window))
                     (window (outline-tree-get-target-window))
                     (buffer (outline-tree-get-buffer-by-node node)))
                 (when (and whole-range (bufferp buffer))
                   (set-window window)
                   (set-buffer buffer)
                   (unless (eq (outline-tree-get-node-by-window) node)
                     (goto-char (outline-tree-get-range-from whole-range))
                     (cond ((and (eq *outline-tree-editor-recenter* :line)
                                 (numberp *outline-tree-editor-recenter-line*)
                                 (integerp *outline-tree-editor-recenter-line*))
                            (recenter *outline-tree-editor-recenter-line*))
                           (*outline-tree-editor-recenter*
                            (recenter))))
                   (when (outline-tree-text-highlight-p)
                     (outline-tree-set-text-highlight whole-range))
                   (set-window swindow)
                   (winapi:InvalidateRect (get-window-handle) 0 1)
                   (winapi:UpdateWindow (get-window-handle))
                   (refresh-screen))))))
        (:point-node
         #'(lambda () (interactive)
             (treeview::with-app (*outline-tree-app-id*)
               (let ((node node)
                     (point (outline-tree-data-get-point node))
                     (swindow (selected-window))
                     (window (outline-tree-get-target-window))
                     (buffer (outline-tree-get-buffer-by-node node)))
                 (when (and point (bufferp buffer))
                   (set-window window)
                   (set-buffer buffer)
                   (goto-char point)
                   (cond ((and (eq *outline-tree-editor-recenter* :line)
                               (numberp *outline-tree-editor-recenter-line*)
                               (integerp *outline-tree-editor-recenter-line*))
                          (recenter *outline-tree-editor-recenter-line*))
                         (*outline-tree-editor-recenter*
                          (recenter)))
                   (set-window swindow)
                   (winapi:InvalidateRect (get-window-handle) 0 1)
                   (winapi:UpdateWindow (get-window-handle))
                   (refresh-screen))))))
        ))))

(defun outline-tree-menu-gen (node)
  "outline-tree: node ɑΉ郁j[𐶐
̒: IĂm[h̃obt@ƃJgobt@͈قȂ
                ꍇ肦̂ŒӁB"
  (setq *outline-tree-context-menu-node* node)
  (let ((menu (create-popup-menu 'outline-tree-menu))
        (context-menu-buffer (outline-tree-get-buffer-by-node node))
        (context-menu-folder (outline-tree-get-folder-by-node node)))

    ;; [U` menu ݂ꍇAgp
    (case (outline-tree-data-get-type node)
      (:buffer-node
       (when *outline-tree-buffer-menu*
         (return-from outline-tree-menu-gen *outline-tree-buffer-menu*)))
      (:folder-node
       (when *outline-tree-folder-menu*
         (return-from outline-tree-menu-gen *outline-tree-folder-menu*))))

    ;; category-node ̏ꍇ
    (when (outline-tree-category-node-p node)
      (add-menu-item menu 'outline-tree-category-close
                     "JeS(&C)"
                     #'(lambda () (interactive)
                         (outline-tree-delete-category-buffers node))))

    ;; folder-node ̏ꍇ
    (when (outline-tree-folder-node-p node)
      (add-menu-item menu 'outline-tree-folder-close
                     "tH_(&C)"
                     #'(lambda () (interactive)
                         (outline-tree-kill-folder-file-buffers context-menu-folder)))
      (unless *filer-modal*
        (add-menu-item menu 'outline-tree-filer-open
                       "t@CJ(&F)"
                       #'(lambda () (interactive)
                           (treeview::with-app (*outline-tree-app-id*)
                             (if (outline-tree-filer-open-p)
                                 (filer-chdir (outline-tree-data-get-folder-name node))
                               (progn
                                 (unless *filer-left-window-p*
                                   (setq *filer-secondary-directory* *filer-primary-directory*)
                                   (setq *filer-left-window-p* t))
                                 (setq *filer-primary-directory*
                                       (outline-tree-data-get-folder-name node))
                                 (open-filer)))
                             (ed::filer-focus)))))
      (add-menu-separator menu))

    (if context-menu-buffer
        ;; buffer-node ȉ̏ꍇ
        (progn
          (add-menu-item menu 'kill-buffer
                         "obt@(&C)"
                         #'(lambda () (interactive)
                             (treeview::with-app (*outline-tree-app-id*)
                               (kill-buffer context-menu-buffer)
                               (winapi:InvalidateRect (get-window-handle) 0 1)
                               (winapi:UpdateWindow (get-window-handle))
                               (refresh-screen))))
          (setq ed::*buffer-bar-context-menu-buffer* context-menu-buffer)
          (add-popup-menu menu ed::*buffer-bar-context-menu*
                          "obt@o[j[(&M)")
          (add-menu-separator menu)
          (add-menu-item menu 'outline-tree-create-outline-by-node
                         "AEgC̍쐬/XV(&A)"
                         #'(lambda () (interactive)
                             (outline-tree-create-outline-by-node node)
                             (refresh-screen)))
          (add-menu-item menu 'outline-tree-delete-outline-by-node
                         "AEgC̍폜(&B)"
                         #'(lambda () (interactive)
                             (outline-tree-delete-outline-by-node node))
                         #'(lambda ()
                             (or (outline-tree-exist-outline-p-by-node node)
                                 :disable)))
          (add-popup-menu menu
                          *outline-tree-create-outline-function-menu*
                          "AEgC^CvI(&S)")
          (add-popup-menu menu
                          *outline-tree-create-outline-function-info-menu*
                          "AEgC^Cv(&P)")
          (add-popup-menu menu
                          (define-popup-menu
                            (:item 'outline-tree-gen-cr-user-topic
                             "uóvݒ肩(&T)"
                             #'(lambda () (interactive)
                                 (treeview::treeview-focus-editor)
                                 (outline-tree-gen-cr-user-topic)))
                            (:item 'outline-tree-gen-cr-user-regexp
                             "uK\vݒ肩(&R)"
                             #'(lambda () (interactive)
                                 (treeview::treeview-focus-editor)
                                 (outline-tree-gen-cr-user-regexp))))
                          "AEgC쐬֐̐(&G)")
          (add-menu-separator menu))
      ;; buffer-node ȉłȂꍇ
      (progn
        (add-popup-menu menu
                        *outline-tree-create-outline-function-info-menu*
                        "AEgC^Cv(&P)")
        (add-menu-separator menu)))

    ;; tab-bar p menu ̐łȂꍇ
    (unless (eql node -1)
      ;; m[h̊J
      (add-popup-menu menu
                      (define-popup-menu
                        (:item nil
                         "SĊJ(&C)"
                         #'(lambda () (interactive) (outline-tree-expand-expand-subtree node))
                         #'(lambda () (or (and (outline-tree-node-valid-p node)
                                               (outline-tree-node-has-children-p node)) :disable)))
                        (:item nil
                         "Sĕ(&D)"
                         #'(lambda () (interactive) (outline-tree-expand-collapse-subtree node))
                         #'(lambda () (or (and (outline-tree-node-valid-p node)
                                               (outline-tree-node-has-children-p node)) :disable)))
                        :sep
                        (:item nil
                         " 2 KwJ(&2)"
                         #'(lambda () (interactive) (outline-tree-expand-expand-subtree node 2))
                         #'(lambda () (or (and (outline-tree-node-valid-p node)
                                               (outline-tree-node-has-children-p node)) :disable)))
                        (:item nil
                         " 3 KwJ(&3)"
                         #'(lambda () (interactive) (outline-tree-expand-expand-subtree node 3))
                         #'(lambda () (or (and (outline-tree-node-valid-p node)
                                               (outline-tree-node-has-children-p node)) :disable)))
                        :sep
                        (:item nil
                         "ȉ̌om[hSČ悤ɊJ(&H)"
                         #'(lambda () (interactive) (outline-tree-expand-expand-subtree-show-heading-node node))
                         #'(lambda () (or (and (outline-tree-node-valid-p node)
                                               (outline-tree-node-has-children-p node)) :disable)))
                        :sep
                        (:item nil
                         "m[hSĊJ(&A)"
                         #'(lambda () (interactive) (outline-tree-expand-expand-subtree 0)))
                        (:item nil
                         "m[hSĕ(&B)"
                         #'(lambda () (interactive) (outline-tree-expand-collapse-subtree 0))))
                      "m[hJ(&E)")
      (add-menu-separator menu))

    ;; range-node ̏ꍇ
    (let (whole-range)
      (when (and (outline-tree-range-node-p node)
                 (setq whole-range (outline-tree-data-get-whole-range node)))
        (add-popup-menu menu
                        (define-popup-menu
                          (:item nil
                           "m[hֈړ(&P)"
                           #'(lambda () (interactive)
                               (outline-tree-swap-region-by-prev-range-node node))
                           #'(lambda ()
                               (or (outline-tree-get-swap-target-range-node node t)
                                   :disable)))
                          (:item nil
                           "m[hֈړ(&N)"
                           #'(lambda () (interactive)
                               (outline-tree-swap-region-by-next-range-node node))
                           #'(lambda ()
                               (or (outline-tree-get-swap-target-range-node node nil)
                                   :disable)))
                          (:item nil
                           "m[h폜(&D)"
                           #'(lambda () (interactive)
                               (outline-tree-delete-region-by-range-node node)))
                          :separator
                          (:item nil
                           "m[h̃Rs[(&C)"
                           #'(lambda () (interactive)
                               (copy-region-to-clipboard
                                (outline-tree-get-range-from whole-range)
                                (outline-tree-get-range-to whole-range))))
                          (:item nil
                           "m[h̐擪Ɉړ(&<)"
                           #'(lambda () (interactive)
                               (goto-char (outline-tree-get-range-from whole-range))
                               (refresh-screen)))
                          (:item nil
                           "m[h̖Ɉړ(&>)"
                           #'(lambda () (interactive)
                               (goto-char (1- (outline-tree-get-range-to whole-range)))
                               (refresh-screen))))
                        "͈̓m[h(&F)")
        (add-menu-separator menu)))

    ;; tab-bar p menu ̐łȂꍇ
    (unless (eql node -1)
      ;; o
      (add-popup-menu menu
                      (define-popup-menu
                        (:popup 'tree-text "c[\(&T)"
                         (:item 'outline-tree-insert-tree-text-root
                          "c[\SĂeLXgo(&A)"
                          #'(lambda () (interactive)
                              (treeview::with-app (*outline-tree-app-id*)
                                (treeview::treeview-insert-tree-text 0);node
                                (treeview::treeview-focus-editor))))
                         (:item 'outline-tree-insert-tree-text-node
                          "̃m[hȉ̃c[\eLXgo(&B)"
                          #'(lambda () (interactive)
                              (treeview::with-app (*outline-tree-app-id*)
                                (treeview::treeview-insert-tree-text node)
                                (treeview::treeview-focus-editor)))))
                        :sep
                        (:popup 'heading-node "om[h(&H)"
                         (:popup 'buffer "obt@S(&B)"
                          (:item 'outline-tree-output-heading-html-buffer
                           "obt@Ŝ 1t@C HTML o(&A)"
                           #'(lambda () (interactive)
                               (outline-tree-output-heading-html
                                (outline-tree-get-buffer-node-by-node node)))
                           #'(lambda () (or (outline-tree-latest-outline-p-by-node node) :disable)))
                          (:item 'outline-tree-output-heading-html-frame-buffer
                           "obt@Ŝ FRAME HTML o(&B)"
                           #'(lambda () (interactive)
                               (outline-tree-output-heading-html-frame
                                (outline-tree-get-buffer-node-by-node node)))
                           #'(lambda () (or (outline-tree-latest-outline-p-by-node node) :disable)))
                          :sep
                          (:item 'outline-tree-output-heading-html-buffer-expand
                           "obt@Ŝ̕\m[h 1t@C HTML o(&C)"
                           #'(lambda () (interactive)
                               (outline-tree-output-heading-html
                                (outline-tree-get-buffer-node-by-node node) :expand))
                           #'(lambda () (or (outline-tree-latest-outline-p-by-node node) :disable)))
                          (:item 'outline-tree-output-heading-html-frame-buffer-expand
                         "obt@Ŝ̕\m[h FRAME HTML o(&D)"
                           #'(lambda () (interactive)
                               (outline-tree-output-heading-html-frame
                                (outline-tree-get-buffer-node-by-node node) :expand))
                           #'(lambda () (or (outline-tree-latest-outline-p-by-node node) :disable)))
                          )
                         (:popup 'node "(&H)"
                          (:item 'outline-tree-output-heading-html-node
                           " 1t@C HTML o(&A)"
                           #'(lambda () (interactive) (outline-tree-output-heading-html node))
                           #'(lambda ()
                               (when (or (outline-tree-buffer-node-p node)
                                         (not (outline-tree-latest-outline-p-by-node node)))
                                 :disable)))
                          (:item 'outline-tree-output-heading-html-frame-node
                           " FRAME HTML o(&B)"
                           #'(lambda () (interactive) (outline-tree-output-heading-html-frame node))
                           #'(lambda ()
                               (when (or (outline-tree-buffer-node-p node)
                                         (not (outline-tree-latest-outline-p-by-node node)))
                                 :disable)))
                          :sep
                          (:item 'outline-tree-output-heading-html-node-expand
                           "\m[h 1t@C HTML o(&C)"
                           #'(lambda () (interactive) (outline-tree-output-heading-html node :expand))
                           #'(lambda ()
                               (when (or (outline-tree-buffer-node-p node)
                                         (not (outline-tree-latest-outline-p-by-node node)))
                                 :disable)))
                          (:item 'outline-tree-output-heading-html-frame-node-expand
                           "\m[h FRAME HTML o(&D)"
                           #'(lambda () (interactive) (outline-tree-output-heading-html-frame node :expand))
                           #'(lambda ()
                               (when (or (outline-tree-buffer-node-p node)
                                         (not (outline-tree-latest-outline-p-by-node node)))
                                 :disable)))
                          ))
                        (:popup 'range-node "͈̓m[h(&R)"
                         (:popup 'buffer "obt@S(&B)"
                          (:item 'outline-tree-output-range-html-buffer
                           "obt@Ŝ 1t@C HTML o(&A)"
                           #'(lambda () (interactive)
                               (outline-tree-output-range-html
                                (outline-tree-get-buffer-node-by-node node)))
                           #'(lambda () (or (outline-tree-latest-outline-p-by-node node) :disable)))
                          (:item 'outline-tree-output-range-html-frame-buffer
                           "obt@Ŝ FRAME HTML o(&B)"
                           #'(lambda () (interactive)
                               (outline-tree-output-range-html-frame
                                (outline-tree-get-buffer-node-by-node node)))
                           #'(lambda () (or (outline-tree-latest-outline-p-by-node node) :disable)))
                          :sep
                          (:item 'outline-tree-output-range-html-buffer-expand
                           "obt@Ŝ̕\m[h 1t@C HTML o(&C)"
                           #'(lambda () (interactive)
                               (outline-tree-output-range-html
                                (outline-tree-get-buffer-node-by-node node) :expand))
                           #'(lambda () (or (outline-tree-latest-outline-p-by-node node) :disable)))
                          (:item 'outline-tree-output-range-html-frame-buffer-expand
                           "obt@Ŝ̕\m[h FRAME HTML o(&D)"
                           #'(lambda () (interactive)
                               (outline-tree-output-range-html-frame
                                (outline-tree-get-buffer-node-by-node node) :expand))
                           #'(lambda () (or (outline-tree-latest-outline-p-by-node node) :disable)))
                          )
                         (:popup 'node "(&H)"
                          (:item 'outline-tree-output-range-html-node
                           " 1t@C HTML o(&A)"
                           #'(lambda () (interactive) (outline-tree-output-range-html node))
                           #'(lambda ()
                               (when (or (outline-tree-buffer-node-p node)
                                         (not (outline-tree-latest-outline-p-by-node node)))
                                 :disable)))
                          (:item 'outline-tree-output-range-html-frame-node
                           " FRAME HTML o(&B)"
                           #'(lambda () (interactive) (outline-tree-output-range-html-frame node))
                           #'(lambda ()
                               (when (or (outline-tree-buffer-node-p node)
                                         (not (outline-tree-latest-outline-p-by-node node)))
                                 :disable)))
                          :sep
                          (:item 'outline-tree-output-range-html-node-expand
                           "\m[h 1t@C HTML o(&C)"
                           #'(lambda () (interactive) (outline-tree-output-range-html node :expand))
                           #'(lambda ()
                               (when (or (outline-tree-buffer-node-p node)
                                         (not (outline-tree-latest-outline-p-by-node node)))
                                 :disable)))
                          (:item 'outline-tree-output-range-html-frame-node-expand
                           "\m[h FRAME HTML o(&D)"
                           #'(lambda () (interactive) (outline-tree-output-range-html-frame node :expand))
                           #'(lambda ()
                               (when (or (outline-tree-buffer-node-p node)
                                         (not (outline-tree-latest-outline-p-by-node node)))
                                 :disable)))
                          )))
                      "o(&O)")
      (add-menu-separator menu))

    ;; tab-bar p menu ̐łȂꍇ
    (unless (eql node -1)
      (add-popup-menu menu
                      (outline-tree-define-target-window-popup-menu)
                      "AEgCΏۃEBhE(&U)"))
    (add-popup-menu menu
                    (define-popup-menu
                      (:item 'outline-tree-toggle-chase-cursor
                       "J[\Ǐ](&C)"
                       'outline-tree-toggle-chase-cursor
                       #'(lambda ()
                           (and (outline-tree-chase-cursor-p) :check)))
                      (:item 'outline-tree-toggle-chase-node
                       "m[hǏ](&N)"
                       'outline-tree-toggle-chase-node
                       #'(lambda ()
                           (and (outline-tree-chase-node-p) :check)))
                      (:item 'outline-tree-toggle-text-highlight
                       "m[h͈̓nCCg(&H)"
                       'outline-tree-toggle-text-highlight
                       #'(lambda ()
                           (and (outline-tree-text-highlight-p) :check)))
                      (:item 'outline-tree-toggle-text-highlight-always
                       "m[h͈͂ɃnCCg(&A)"
                       'outline-tree-toggle-text-highlight-always
                       #'(lambda ()
                           (and (outline-tree-text-highlight-always-p) :check)))
                      (:item 'outline-tree-toggle-available-swap-discontinuous-range-node
                       "sAm[hւ(&D)"
                       'outline-tree-toggle-available-swap-discontinuous-range-node
                       #'(lambda ()
                           (and (outline-tree-available-swap-discontinuous-range-node-p) :check))))
                    "AEgCc[ȈՐݒ(&Y)")
    (add-menu-item menu 'outline-tree-option-property-sheet
                   "AEgCc[ݒ(&Z)..."
                   #'(lambda ()
                       (interactive)
                       (save-window-excursion
                         (save-excursion
                           (set-buffer (outline-tree-get-buffer-by-node node))
                           (outline-tree-option-property-sheet)))))
    (add-menu-separator menu)
    (add-menu-item menu 'treeview::treeview-std-dialog
                   "TreeView ݒ(&D)..."
                   #'(lambda () (interactive)
                       (treeview::with-app (*outline-tree-app-id*)
                         (treeview::treeview-std-dialog)
                         (treeview::treeview-focus-treeview))))
    (add-popup-menu menu
                    (treeview::treeview-popup-menu-position)
                    "EBhEʒuύX(&W)")
    (add-popup-menu menu
                    (define-popup-menu
                      (:item 'treeview::treeview-describe-bindings
                       "L[蓖Ĉꗗ(&K)"
                       #'(lambda () (interactive)
                           (treeview::with-app (*outline-tree-app-id*)
                             (treeview::treeview-describe-bindings))))
                      (:item 'treeview::treeview-describe-key-briefly
                       "L[(&B)"
                       #'(lambda () (interactive)
                           (treeview::with-app (*outline-tree-app-id*)
                             (call-interactively 'treeview::treeview-describe-key-briefly)))))
                    "wv(&?)")
    (add-menu-separator menu)
    (add-menu-item menu 'outline-tree-open
                   "outline-tree J(&T)"
                   'outline-tree-open
                   #'(lambda () (and (outline-tree-open-p) :disable)))
    (add-menu-item menu 'outline-tree-close
                   "outline-tree (&T)"
                   'outline-tree-close
                   #'(lambda () (and (outline-tree-close-p) :disable)))
    (add-menu-item menu 'outline-tree-delete
                   "outline-tree ̏I(&X)" 'outline-tree-delete)
    (when *outline-tree-debug*
      (add-menu-item menu 'outline-tree-get-enum-node-data-msgbox
                     "m[hf[^"
                     #'(lambda () (interactive)
                         (msgbox "~{~S~%~}" (outline-tree-get-enum-node-data node)))))
    menu))

(defun outline-tree-initialize-icons ()
  "treeview  icon ݒ"
  (treeview::with-app (*outline-tree-app-id*)
    (when (outline-tree-exist-p)
      (treeview::treeview-remove-all-icons)
      (if *outline-tree-icon*
          (dolist (x *outline-tree-icon-symbol-file-alist*)
            (set (car x)
                 (treeview::treeview-add-file-icon
                  (map-slash-to-backslash
                   (merge-pathnames (cdr x) *outline-tree-icon-directory*)))))
        (dolist (x *outline-tree-icon-symbol-file-alist*)
          (set (car x) nil)))
      (treeview::treeview-refresh-treeview))))

;;----------------------------------------------------------------------------
;; TREEVIEW Cu֓o^
;;----------------------------------------------------------------------------
(treeview::treeview-app-id-register *outline-tree-app-id*)
(defun outline-tree-initialize-treeview ()
  (treeview::with-app (*outline-tree-app-id*)
    (treeview::treeview-data-set 'treeview::display-name "outline-tree")
    ;; window position/size/display
    (treeview::treeview-data-reference-set 'treeview::window-position '*outline-tree-window-position*)
    (treeview::treeview-data-reference-set 'treeview::window-width '*outline-tree-window-width*)
    (treeview::treeview-data-reference-set 'treeview::window-height '*outline-tree-window-height*)
    (treeview::treeview-data-reference-set 'treeview::window-display-style '*outline-tree-window-display-style*)
    ;; color
    (treeview::treeview-data-reference-set 'treeview::color-text-manual-p '*outline-tree-color-text-manual-p*)
    (treeview::treeview-data-reference-set 'treeview::color-text '*outline-tree-color-text*)
    (treeview::treeview-data-reference-set 'treeview::color-bk-manual-p '*outline-tree-color-bk-manual-p*)
    (treeview::treeview-data-reference-set 'treeview::color-bk '*outline-tree-color-bk*)
    ;; font
    (treeview::treeview-data-reference-set 'treeview::font-facename-manual-p '*outline-tree-font-facename-manual-p*)
    (treeview::treeview-data-reference-set 'treeview::font-facename '*outline-tree-font-facename*)
    (treeview::treeview-data-reference-set 'treeview::font-height-manual-p '*outline-tree-font-height-manual-p*)
    (treeview::treeview-data-reference-set 'treeview::font-height '*outline-tree-font-height*)
    (treeview::treeview-data-reference-set 'treeview::font-bold '*outline-tree-font-bold*)
    (treeview::treeview-data-reference-set 'treeview::font-italic '*outline-tree-font-italic*)
    (treeview::treeview-data-reference-set 'treeview::font-underline '*outline-tree-font-underline*)
    ;; style
    (treeview::treeview-data-reference-set 'treeview::style-hasbuttons '*outline-tree-style-hasbuttons*)
    (treeview::treeview-data-reference-set 'treeview::style-haslines '*outline-tree-style-haslines*)
    (treeview::treeview-data-reference-set 'treeview::style-linesatroot '*outline-tree-style-linesatroot*)
    (treeview::treeview-data-reference-set 'treeview::style-editlabels '*outline-tree-style-editlabels*)
    (treeview::treeview-data-reference-set 'treeview::style-enabledragdrop '*outline-tree-style-enabledragdrop*)
    (treeview::treeview-data-reference-set 'treeview::style-showselalways '*outline-tree-style-showselalways*)
    (treeview::treeview-data-reference-set 'treeview::style-rtlreading '*outline-tree-style-rtlreading*)
    (treeview::treeview-data-reference-set 'treeview::style-tooltips '*outline-tree-style-tooltips*)
    (treeview::treeview-data-reference-set 'treeview::style-checkboxes '*outline-tree-style-checkboxes*)
    (treeview::treeview-data-reference-set 'treeview::style-trackselect '*outline-tree-style-trackselect*)
    (treeview::treeview-data-reference-set 'treeview::style-singleexpand '*outline-tree-style-singleexpand*)
    (treeview::treeview-data-reference-set 'treeview::style-infotip '*outline-tree-style-infotip*)
    (treeview::treeview-data-reference-set 'treeview::style-fullrowselect '*outline-tree-style-fullrowselect*)
    (treeview::treeview-data-reference-set 'treeview::style-scroll '*outline-tree-style-scroll*)
    (treeview::treeview-data-reference-set 'treeview::style-nonevenheight '*outline-tree-style-nonevenheight*)
    (treeview::treeview-data-reference-set 'treeview::style-hscroll '*outline-tree-style-hscroll*)
    ;; indent
    (treeview::treeview-data-reference-set 'treeview::indent-manual-p '*outline-tree-indent-manual-p*)
    (treeview::treeview-data-reference-set 'treeview::indent '*outline-tree-indent*)
    ;; height
    (treeview::treeview-data-reference-set 'treeview::item-height-manual-p '*outline-tree-item-height-manual-p*)
    (treeview::treeview-data-reference-set 'treeview::item-height '*outline-tree-item-height*)
    ;; icon
    (treeview::treeview-data-reference-set 'treeview::icon '*outline-tree-icon*)
    (treeview::treeview-data-reference-set 'treeview::icon-directory '*outline-tree-icon-directory*)
    (treeview::treeview-data-set 'treeview::initialize-icons-func 'outline-tree-initialize-icons)
    ;; keymap
    (treeview::treeview-data-set 'treeview::fix-keymap-symbol '*outline-tree-fix-map*)
    (treeview::treeview-data-set 'treeview::keymap-symbol '*outline-tree-map*)
    ;; mouse
    (treeview::treeview-data-set 'treeview::menu-gen 'outline-tree-menu-gen)
    ;; func
    (treeview::treeview-data-set 'treeview::implicit-func-gen 'outline-tree-node-implicit-func-gen)
    (treeview::treeview-data-set 'treeview::explicit-func-gen 'outline-tree-node-explicit-func-gen)
    ;; exclusive-open-group
    (treeview::treeview-data-reference-set 'treeview::exclusive-open-group '*outline-tree-exclusive-open-group*)
    ;; scroll
    (treeview::treeview-data-reference-set 'treeview::recenter '*outline-tree-treeview-recenter*)
    (treeview::treeview-data-reference-set 'treeview::recenter-line '*outline-tree-treeview-recenter-line*)
    (treeview::treeview-data-reference-set 'treeview::scroll-margin '*outline-tree-treeview-scroll-margin*)
    ))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;----------------------------------------------------------------------------
;; GfB^\s
;;----------------------------------------------------------------------------
(define-history-variable *outline-tree-editor-recenter* :line "t, nil, :line")
(define-history-variable *outline-tree-editor-recenter-line* 3)

;;----------------------------------------------------------------------------
;; 쐬WJKw (buffer-node ̐[)
;;----------------------------------------------------------------------------
(define-history-variable *outline-tree-expand-on-create-outline* :depth "t, nil, :depth")
(define-history-variable *outline-tree-expand-depth-on-create-outline* 1)

;;----------------------------------------------------------------------------
;; J[\Ǐ]WJKw (buffer-node ̐[)
;;----------------------------------------------------------------------------
(define-history-variable *outline-tree-expand-on-chase-cursor* :depth "t, nil, :depth")
(define-history-variable *outline-tree-expand-depth-on-chase-cursor* 3)

;;----------------------------------------------------------------------------
;; TreeView Cubp֐
;;----------------------------------------------------------------------------
(defun outline-tree-exist-p ()
  (treeview::with-app (*outline-tree-app-id*)
    (treeview::treeview-exist-p)))
(defun outline-tree-open ()
  (interactive)
  (treeview::with-app (*outline-tree-app-id*)
    (treeview::treeview-open)))
(defun outline-tree-close ()
  (interactive)
  (treeview::with-app (*outline-tree-app-id*)
    (treeview::treeview-close)))
(defun outline-tree-open-p ()
  (treeview::with-app (*outline-tree-app-id*)
    (treeview::treeview-open-p)))
(defun outline-tree-close-p ()
  (treeview::with-app (*outline-tree-app-id*)
    (treeview::treeview-close-p)))
(defun outline-tree-node-valid-p (node)
  (treeview::treeview-hitem-valid-p node))
(defun outline-tree-node-has-children-p (node)
  (treeview::with-app (*outline-tree-app-id*)
    (treeview::treeview-item-has-children-p node)))
(defun outline-tree-get-selected-node ()
  (when (outline-tree-exist-p)
    (treeview::with-app (*outline-tree-app-id*)
      (treeview::treeview-get-selected-item))))

;;----------------------------------------------------------------------------
;; {[UR}h
;;----------------------------------------------------------------------------
(defun outline-tree-node-implicit-action (&optional node)
  (interactive)
  (let ((func (outline-tree-node-implicit-func-gen node)))
    (when func (funcall func))))
(defun outline-tree-node-explicit-action (&optional node)
  (interactive)
  (let ((func (outline-tree-node-explicit-func-gen node)))
    (when func (funcall func))))
(defun outline-tree-node-action (&optional node)
  (interactive)
  (let ((func (or (outline-tree-node-explicit-func-gen node)
                  (outline-tree-node-implicit-func-gen node))))
    (when func (funcall func))))

;;----------------------------------------------------------------------------
;; TREEVIEW 쐬/폜/ACXg[
;;----------------------------------------------------------------------------
(defun outline-tree-create ()
  "outline-tree: AEgCc[쐬"
  (interactive)
  (outline-tree-autoload)
  (outline-tree-config-load)
  (when (eq *outline-tree-use* nil)
    (setq *outline-tree-use* t))
  (outline-tree-initialize-treeview)
  (outline-tree-create-outline-function-menu-gen)
  (outline-tree-create-outline-function-info-menu-gen)
  (unless (outline-tree-exist-p)
    (treeview::treeview-create-ex
     *outline-tree-app-id*
     (if (find *outline-tree-window-position*
               (list treeview::XPIS_LEFT treeview::XPIS_RIGHT))
         *outline-tree-window-width*
       *outline-tree-window-height*)
     *outline-tree-window-position*)
    (clrhash *outline-tree-node-hash*)
    (clrhash *outline-tree-folder-hash*)
    (clrhash *outline-tree-category-hash*)
    (clrhash *outline-tree-buffer-hash*)
    (add-hook '*create-buffer-hook* 'outline-tree-create-buffer-node-by-buffer)
    (add-hook '*find-file-hooks* 'outline-tree-create-buffer-node-by-buffer)
    (add-hook '*after-save-buffer-hook* 'outline-tree-create-buffer-node-by-buffer)
    (add-hook '*delete-buffer-hook* 'outline-tree-delete-buffer-node-by-buffer)
    (add-hook '*pre-command-hook* 'outline-tree-delete-text-highlight)
    (add-hook '*post-command-hook* 'outline-tree-select-node-by-window-for-hook)
    (when (boundp 'ed::*after-rename-buffer-hook*)
      (add-hook 'ed::*after-rename-buffer-hook* 'outline-tree-create-buffer-node-by-buffer))
    (treeview::with-app (*outline-tree-app-id*)
      ;; NŗL - Jn
      (outline-tree-create-buffer-node-by-buffer (buffer-list))
      (outline-tree-initialize-expand-node)
      (outline-tree-sort-folder-node)
      (outline-tree-select-node)
      (outline-tree-update-modified-buffer-node-name-view)
      ;; NŗL - I
      (treeview::treeview-focus-editor)
      (treeview::treeview-refresh-treeview)))
  (run-hooks '*outline-tree-create-hook*))

(defun outline-tree-delete ()
  "outline-tree: AEgCc[폜"
  (interactive)
  (when (eq *outline-tree-use* t)
    (setq *outline-tree-use* nil))
  (maphash #'(lambda (buffer node)
               (if (and (not (deleted-buffer-p buffer))
                        (gethash buffer *outline-tree-buffer-hash*))
                   (outline-tree-delete-buffer-node-by-buffer buffer)))
           *outline-tree-buffer-hash*)
  (treeview::with-app (*outline-tree-app-id*)
    (treeview::treeview-delete))
  (delete-hook '*create-buffer-hook* 'outline-tree-create-buffer-node-by-buffer)
  (delete-hook '*find-file-hooks* 'outline-tree-create-buffer-node-by-buffer)
  (delete-hook '*after-save-buffer-hook* 'outline-tree-create-buffer-node-by-buffer)
  (delete-hook '*delete-buffer-hook* 'outline-tree-delete-buffer-node-by-buffer)
  (delete-hook '*pre-command-hook* 'outline-tree-delete-text-highlight)
  (delete-hook '*post-command-hook* 'outline-tree-select-node-by-window-for-hook)
  (when (boundp 'ed::*after-rename-buffer-hook*)
    (delete-hook 'ed::*after-rename-buffer-hook* 'outline-tree-create-buffer-node-by-buffer))
  (treeview::treeview-focus-editor)
  (refresh-screen)
  (run-hooks '*outline-tree-delete-hook*))

(defun outline-tree-toggle ()
  "outline-tree: AEgCc[̎gpgO"
  (interactive)
  (if (outline-tree-exist-p)
      (outline-tree-delete)
    (outline-tree-create)))

(defun outline-tree-uninstall ()
  "outline-tree: ACXg["
  (outline-tree-delete)
  (outline-tree-delete-menu)
  (run-hooks '*outline-tree-uninstall-hook*)
  (let ((package (find-package "outline-tree2")))
    (dolist (x (copy-list ed::*history-variable-list*))
      (if (eq (symbol-package x) package)
          (unregister-history-variable x)))))

;;----------------------------------------------------------------------------
;; j[o^/폜
;;----------------------------------------------------------------------------
(defun outline-tree-insert-menu-items (&key menu position head-sep tail-sep)
  "outline-tree: j[֓o^"
  (treeview::with-app (*outline-tree-app-id*)
    (if (and (not (menup menu)) (menup *app-menu*))
        (setq menu (get-menu *app-menu* 'ed::view)))
    (when (menup menu)
      (outline-tree-delete-menu menu)
      (unless (and (numberp position) (integerp position) (not (minusp position))
                   (get-menu menu position t))
        (setq position -1)
        (while (get-menu menu (incf position) t)))
      (decf position)
      (if (and head-sep
               (not (minusp position))
               (get-menu menu position t))
          (insert-menu-separator menu (incf position) 'outline-tree-sep))
      (insert-menu-item menu (incf position) 'outline-tree-toggle
                        "AEgCc[(&O)"
                        'outline-tree-toggle
                        #'(lambda ()
                            (and (outline-tree-exist-p) :check)))
      (if (and tail-sep
               (get-menu menu (incf position) t))
          (insert-menu-separator menu position 'outline-tree-sep)))))
(defun outline-tree-delete-menu (&optional menu)
  "outline-tree: j[폜"
  (if (and (not (menup menu)) (menup *app-menu*))
      (setq menu (get-menu *app-menu* 'ed::view)))
  (when (menup menu)
    (while (delete-menu menu 'outline-tree-toggle))
    (while (delete-menu menu 'outline-tree-sep))))

;;----------------------------------------------------------------------------
;; ŗLACR
;;----------------------------------------------------------------------------
(defvar *outline-tree-icon-id-buffer* nil)
(defvar *outline-tree-icon-id-file* nil)
(defvar *outline-tree-icon-id-folder* nil)
(defvar *outline-tree-icon-id-category* nil)
(defvar *outline-tree-icon-id-range* nil)
(defvar *outline-tree-icon-id-range1* nil)
(defvar *outline-tree-icon-id-range2* nil)
(defvar *outline-tree-icon-id-point* nil)
(defvar *outline-tree-icon-id-info* nil)
(defvar *outline-tree-icon-id-section* nil)
(defvar *outline-tree-icon-id-heading* nil)
(defvar *outline-tree-icon-id-heading1* nil)
(defvar *outline-tree-icon-id-heading2* nil)
(defvar *outline-tree-icon-id-header* nil)

(defvar *outline-tree-icon-symbol-file-alist*
  '((*outline-tree-icon-id-buffer*   . "buffer.ico")
    (*outline-tree-icon-id-file*     . "file.ico")
    (*outline-tree-icon-id-folder*   . "folder.ico")
    (*outline-tree-icon-id-category* . "category.ico")
    (*outline-tree-icon-id-range*    . "range.ico")
    (*outline-tree-icon-id-range1*   . "range1.ico")
    (*outline-tree-icon-id-range2*   . "range2.ico")
    (*outline-tree-icon-id-point*    . "point.ico")
    (*outline-tree-icon-id-info*     . "info.ico")
    (*outline-tree-icon-id-section*  . "section.ico")
    (*outline-tree-icon-id-heading*  . "heading.ico")
    (*outline-tree-icon-id-heading1* . "heading1.ico")
    (*outline-tree-icon-id-heading2* . "heading2.ico")
    (*outline-tree-icon-id-header*   . "header.ico")))

;;----------------------------------------------------------------------------
;; f[^ۑ@\
;;----------------------------------------------------------------------------
(defvar *outline-tree-node-hash* (make-hash-table)
  "node ɑΉ擾")

(defun outline-tree-data-hash (node)
  (let ((hash (gethash node *outline-tree-node-hash*)))
    (unless hash
      (setq hash (make-hash-table :test #'equal))
      (setf (gethash node *outline-tree-node-hash*) hash))
    hash))
(defun outline-tree-data-set (node key value &optional hash)
  (unless hash
    (setq hash (outline-tree-data-hash node)))
  (setf (gethash key hash) value))
(defun outline-tree-data-get (node key &optional default hash)
  (unless hash
    (setq hash (gethash node *outline-tree-node-hash*)))
  (if hash
      (gethash key hash default)
    (values default nil)))
(defun outline-tree-data-del (node)
  (remhash node *outline-tree-node-hash*))
(defun outline-tree-get-enum-node-data (node)
  (let ((hash (gethash node *outline-tree-node-hash*)) lst)
    (when hash
      (maphash #'(lambda (key data)
                   (pushnew (cons key data) lst
                            :key #'car :test #'equal))
               hash))
    (sort lst #'string<= :key #'car)))

;;----------------------------------------------------------------------------
;; f[^\
;;----------------------------------------------------------------------------
;; ef[^擾
(defun outline-tree-data-get-type (node)
  (outline-tree-data-get node "type"))
(defun outline-tree-data-get-node-name (node)
  (outline-tree-data-get node "node-name"))
(defun outline-tree-data-get-implicit-func (node)
  (outline-tree-data-get node "implicit-func"))
(defun outline-tree-data-get-explicit-func (node)
  (outline-tree-data-get node "explicit-func"))

(defun outline-tree-data-get-sub-type (node)
  (outline-tree-data-get node "sub-type"))
(defun outline-tree-data-get-group-count (node)
  (outline-tree-data-get node "group-count" 0))
(defun outline-tree-data-get-folder-name (node)
  (outline-tree-data-get node "folder-name"))
(defun outline-tree-data-get-category-name (node)
  (outline-tree-data-get node "category-name"))
(defun outline-tree-data-get-buffer (node)
  (outline-tree-data-get node "buffer"))
(defun outline-tree-data-get-buffer-name (node)
  (outline-tree-data-get node "buffer-name"))
(defun outline-tree-data-get-namestring (node)
  (outline-tree-data-get node "namestring"))
(defun outline-tree-data-get-range-name (node)
  (outline-tree-data-get node "range-name"))
(defun outline-tree-data-get-point-name (node)
  (outline-tree-data-get node "point-name"))
(defun outline-tree-data-get-info-name (node)
  (outline-tree-data-get node "info-name"))
(defun outline-tree-data-get-section-name (node)
  (outline-tree-data-get node "section-name"))
(defun outline-tree-data-get-title-range (node)
  (outline-tree-data-get node "title-range"))
(defun outline-tree-data-get-contents-range (node)
  (outline-tree-data-get node "contents-range"))
(defun outline-tree-data-get-whole-range (node)
  (outline-tree-data-get node "whole-range"))
(defun outline-tree-data-get-point (node)
  (outline-tree-data-get node "point"))

;; R}hpf[^ݒ/擾
(defun outline-tree-data-set-output-range (node output-range)
  (outline-tree-data-set node "output-range" (copy-list output-range)))
(defun outline-tree-data-get-output-range (node)
  (outline-tree-data-get node "output-range"))

;; m[h^`FbN
(defun outline-tree-buffer-node-p (node)
  (eq (outline-tree-data-get-type node) :buffer-node))
(defun outline-tree-folder-node-p (node)
  (eq (outline-tree-data-get-type node) :folder-node))
(defun outline-tree-category-node-p (node)
  (eq (outline-tree-data-get-type node) :category-node))
(defun outline-tree-range-node-p (node)
  (eq (outline-tree-data-get-type node) :range-node))
(defun outline-tree-point-node-p (node)
  (eq (outline-tree-data-get-type node) :point-node))
(defun outline-tree-info-node-p (node)
  (eq (outline-tree-data-get-type node) :info-node))
(defun outline-tree-section-node-p (node)
  (eq (outline-tree-data-get-type node) :section-node))
(defun outline-tree-heading-node-p (node)
  (and (eq (outline-tree-data-get-type node) :range-node)
       (eq (outline-tree-data-get-sub-type node) :heading-node)))
(defun outline-tree-header-node-p (node)
  (and (eq (outline-tree-data-get-type node) :range-node)
       (eq (outline-tree-data-get-sub-type node) :header-node)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ŗL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;----------------------------------------------------------------------------
;; f[^m[h̋t
;;----------------------------------------------------------------------------
;; folder-node
(defvar *outline-tree-folder-hash* (make-hash-table :test #'equalp)
  "folder-name ɑΉ node 擾")
(defun outline-tree-revdata-set-folder-node (folder-name node)
  (setf (gethash folder-name *outline-tree-folder-hash*) node))
(defun outline-tree-revdata-get-folder-node (folder-name)
  (gethash folder-name *outline-tree-folder-hash*))
(defun outline-tree-revdata-del-folder-node (folder-name)
  (remhash folder-name *outline-tree-folder-hash*))

;; category-node
(defvar *outline-tree-category-hash* (make-hash-table :test #'equalp)
  "category-name ɑΉ node 擾")
(defun outline-tree-revdata-set-category-node (category-name node)
  (treeview::with-app (*outline-tree-app-id*)
    (let ((parent-node (treeview::treeview-get-parent-item node)))
      (setf (gethash (cons category-name parent-node) *outline-tree-category-hash*) node))))
(defun outline-tree-revdata-get-category-node (category-name &optional (parent-node 0))
  (if (and (numberp parent-node) (minusp parent-node))
      (setq parent-node 0))
  (gethash (cons category-name parent-node) *outline-tree-category-hash*))
(defun outline-tree-revdata-del-category-node (node); node wɒ
  (treeview::with-app (*outline-tree-app-id*)
    (let ((name (outline-tree-data-get-category-name node))
          (parent-node (treeview::treeview-get-parent-item node)))
      (remhash (cons name parent-node) *outline-tree-category-hash*))))

;; buffer-node
(defvar *outline-tree-buffer-hash* (make-hash-table)
  "buffer ɑΉ node 擾")
(defun outline-tree-revdata-set-buffer-node (buffer node)
  (setf (gethash buffer *outline-tree-buffer-hash*) node))
(defun outline-tree-revdata-get-buffer-node (buffer)
  (gethash buffer *outline-tree-buffer-hash*))
(defun outline-tree-revdata-del-buffer-node (buffer)
  (remhash buffer *outline-tree-buffer-hash*))

;;----------------------------------------------------------------------------
;; m[hf[^o^
;;----------------------------------------------------------------------------
(defun outline-tree-register-node (node type node-name implicit-func explicit-func)
  (outline-tree-data-set node "type" type)
  (outline-tree-data-set node "node-name" node-name)
  (outline-tree-data-set node "implicit-func" implicit-func)
  (outline-tree-data-set node "explicit-func" explicit-func)
  node)
(defun outline-tree-update-node (node &key (group-count nil group-count-sv)
                                           (node-name nil node-name-sv)
                                           (implicit-func nil implicit-func-sv)
                                           (explicit-func nil explicit-func-sv))
  (let ((hash (outline-tree-data-hash node)))
    (when group-count-sv
      (outline-tree-data-set node "group-count" group-count hash))
    (when node-name-sv
      (outline-tree-data-set node "node-name" node-name hash))
    (when implicit-func-sv
      (outline-tree-data-set node "implicit-func" implicit-func hash))
    (when explicit-func-sv
      (outline-tree-data-set node "explicit-func" explicit-func hash))
    node))

;; folder-node
(defun outline-tree-register-folder-node (folder-name node &key implicit-func explicit-func)
  (outline-tree-revdata-set-folder-node folder-name node)
  (outline-tree-data-set node "folder-name" folder-name)
  (outline-tree-register-node node :folder-node folder-name implicit-func explicit-func))
(defun outline-tree-unregister-folder-node (node)
  (let ((name (outline-tree-data-get-folder-name node)))
    (outline-tree-revdata-del-folder-node name)
    (outline-tree-data-del node)))
(defun outline-tree-update-folder-node (node &key (folder-name nil folder-name-sv)
                                                  (implicit-func nil implicit-func-sv)
                                                  (explicit-func nil explicit-func-sv))
  (let ((hash (outline-tree-data-hash node)))
    (when folder-name-sv
      (outline-tree-revdata-del-folder-node (outline-tree-data-get-folder-name node))
      (outline-tree-revdata-set-folder-node folder-name node)
      (outline-tree-data-set node "folder-name" folder-name hash)
      (outline-tree-data-set node "node-name" folder-name hash)
      (treeview::with-app (*outline-tree-app-id*)
        (treeview::treeview-set-item-text node folder-name)))
    (when implicit-func-sv
      (outline-tree-data-set node "implicit-func" implicit-func hash))
    (when explicit-func-sv
      (outline-tree-data-set node "explicit-func" explicit-func hash))
    node))

;; category-node
(defun outline-tree-register-category-node (category-name node &key implicit-func explicit-func)
  (outline-tree-revdata-set-category-node category-name node)
  (outline-tree-data-set node "category-name" category-name)
  (outline-tree-register-node node :category-node category-name implicit-func explicit-func))
(defun outline-tree-unregister-category-node (node)
  (outline-tree-revdata-del-category-node node)
  (outline-tree-data-del node))
(defun outline-tree-update-category-node (node &key (category-name nil category-name-sv)
                                                    (implicit-func nil implicit-func-sv)
                                                    (explicit-func nil explicit-func-sv))
  (let ((hash (outline-tree-data-hash node)))
    (when category-name-sv
      (outline-tree-revdata-del-category-node (outline-tree-data-get-category-name node))
      (outline-tree-revdata-set-category-node category-name node)
      (outline-tree-data-set node "category-name" category-name hash)
      (outline-tree-data-set node "node-name" category-name hash)
      (treeview::with-app (*outline-tree-app-id*)
        (treeview::treeview-set-item-text node category-name)))
    (when implicit-func-sv
      (outline-tree-data-set node "implicit-func" implicit-func hash))
    (when explicit-func-sv
      (outline-tree-data-set node "explicit-func" explicit-func hash))
    node))

;; buffer-node
(defun outline-tree-register-buffer-node (buffer node &key buffer-name namestring implicit-func explicit-func)
  (outline-tree-revdata-set-buffer-node buffer node)
  (outline-tree-data-set node "buffer" buffer)
  (outline-tree-data-set node "buffer-name" buffer-name)
  (outline-tree-data-set node "namestring" namestring)
  (let ((node-name (if namestring (file-namestring namestring) buffer-name)))
    (outline-tree-register-node node :buffer-node node-name implicit-func explicit-func)))
(defun outline-tree-unregister-buffer-node (node)
  (let ((buffer (outline-tree-data-get-buffer node)))
    (outline-tree-revdata-del-buffer-node buffer)
    (outline-tree-data-del node)))
(defun outline-tree-update-buffer-node (node &key (buffer nil buffer-sv)
                                                  (implicit-func nil implicit-func-sv)
                                                  (explicit-func nil explicit-func-sv))
  (let ((hash (outline-tree-data-hash node))
        buffer-name namestring file-name node-name)
    (when buffer-sv
      (outline-tree-revdata-del-buffer-node (outline-tree-data-get-buffer node))
      (outline-tree-revdata-set-buffer-node buffer node)
      (outline-tree-data-set node "buffer" buffer hash)
      (setq buffer-name (buffer-name buffer))
      (setq namestring (get-buffer-file-name buffer))
      (when namestring
        (setq file-name (file-namestring namestring)))
      (setq node-name (or file-name buffer-name))
      (outline-tree-data-set node "buffer-name" buffer-name hash)
      (outline-tree-data-set node "namestring" namestring hash)
      (treeview::with-app (*outline-tree-app-id*)
        (treeview::treeview-set-item-text node node-name)))
    (when implicit-func-sv
      (outline-tree-data-set node "implicit-func" implicit-func hash))
    (when explicit-func-sv
      (outline-tree-data-set node "explicit-func" explicit-func hash))
    node))

;; range-node
(defun outline-tree-register-range-node (range-name node
                                         &key title-range contents-range whole-range sub-type
                                              implicit-func explicit-func)
  (outline-tree-data-set node "range-name" range-name)
  (outline-tree-data-set node "title-range" title-range)
  (outline-tree-data-set node "contents-range" contents-range)
  (outline-tree-data-set node "whole-range" whole-range)
  (outline-tree-data-set node "sub-type" sub-type)
  (outline-tree-register-node node :range-node range-name implicit-func explicit-func))
(defun outline-tree-unregister-range-node (node)
  (outline-tree-data-del node))
(defun outline-tree-update-range-node (node &key (range-name nil range-name-sv)
                                                 (title-range nil title-range-sv)
                                                 (contents-range nil contents-range-sv)
                                                 (whole-range nil whole-range-sv)
                                                 (implicit-func nil implicit-func-sv)
                                                 (explicit-func nil explicit-func-sv))
  (let ((hash (outline-tree-data-hash node)))
    (when range-name-sv
      (outline-tree-data-set node "range-name" range-name hash)
      (outline-tree-data-set node "node-name" range-name hash)
      (treeview::with-app (*outline-tree-app-id*)
        (treeview::treeview-set-item-text node range-name)))
    (when title-range-sv
      (outline-tree-data-set node "title-range" (copy-list title-range) hash))
    (when contents-range-sv
      (outline-tree-data-set node "contents-range" (copy-list contents-range) hash))
    (when whole-range-sv
      (outline-tree-data-set node "whole-range" (copy-list whole-range) hash))
    (when implicit-func-sv
      (outline-tree-data-set node "implicit-func" (copy-list implicit-func) hash))
    (when explicit-func-sv
      (outline-tree-data-set node "explicit-func" (copy-list explicit-func) hash))
    node))

;; point-node
(defun outline-tree-register-point-node (point-name node &key point implicit-func explicit-func)
  (outline-tree-data-set node "point-name" point-name)
  (outline-tree-data-set node "point" point)
  (outline-tree-register-node node :point-node point-name implicit-func explicit-func))
(defun outline-tree-unregister-point-node (node)
  (outline-tree-data-del node))
(defun outline-tree-update-point-node (node &key (point-name nil point-name-sv)
                                                 (point nil point-sv)
                                                 (implicit-func nil implicit-func-sv)
                                                 (explicit-func nil explicit-func-sv))
  (let ((hash (outline-tree-data-hash node)))
    (when point-name-sv
      (outline-tree-data-set node "point-name" point-name hash)
      (outline-tree-data-set node "node-name" point-name hash)
      (treeview::with-app (*outline-tree-app-id*)
        (treeview::treeview-set-item-text node point-name)))
    (when point-sv
      (outline-tree-data-set node "point" point hash))
    (when implicit-func-sv
      (outline-tree-data-set node "implicit-func" implicit-func hash))
    (when explicit-func-sv
      (outline-tree-data-set node "explicit-func" explicit-func hash))
    node))

;; info-node
(defun outline-tree-register-info-node (info-name node &key implicit-func explicit-func)
  (outline-tree-data-set node "info-name" info-name)
  (outline-tree-register-node node :info-node info-name implicit-func explicit-func))
(defun outline-tree-unregister-info-node (node)
  (outline-tree-data-del node))
(defun outline-tree-update-info-node (node &key (info-name nil info-name-sv)
                                                (implicit-func nil implicit-func-sv)
                                                (explicit-func nil explicit-func-sv))
  (let ((hash (outline-tree-data-hash node)))
    (when info-name-sv
      (outline-tree-data-set node "info-name" info-name hash)
      (outline-tree-data-set node "node-name" info-name hash)
      (treeview::with-app (*outline-tree-app-id*)
        (treeview::treeview-set-item-text node info-name)))
    (when implicit-func-sv
      (outline-tree-data-set node "implicit-func" implicit-func hash))
    (when explicit-func-sv
      (outline-tree-data-set node "explicit-func" explicit-func hash))
    node))

;; section-node
(defun outline-tree-register-section-node (section-name node &key implicit-func explicit-func)
  (outline-tree-data-set node "section-name" section-name)
  (outline-tree-register-node node :section-node section-name implicit-func explicit-func))
(defun outline-tree-unregister-section-node (node)
  (outline-tree-data-del node))
(defun outline-tree-update-section-node (node &key (section-name nil section-name-sv)
                                                   (implicit-func nil implicit-func-sv)
                                                   (explicit-func nil explicit-func-sv))
  (let ((hash (outline-tree-data-hash node)))
    (when section-name-sv
      (outline-tree-data-set node "section-name" section-name hash)
      (outline-tree-data-set node "node-name" section-name hash)
      (treeview::with-app (*outline-tree-app-id*)
        (treeview::treeview-set-item-text node section-name)))
    (when implicit-func-sv
      (outline-tree-data-set node "implicit-func" implicit-func hash))
    (when explicit-func-sv
      (outline-tree-data-set node "explicit-func" explicit-func hash))
    node))

;;----------------------------------------------------------------------------
;; m[hP̒ǉ
;;----------------------------------------------------------------------------
(define-history-variable *outline-tree-abbreviate-display-folder-name-length* 0
  "tH_m[h̕\
0 w肵ꍇA\̏ȗȂ")
(defun outline-tree-abbreviate-display-folder-name (&optional length)
  "tH_m[h̕\ύXB"
  (treeview::with-app (*outline-tree-app-id*)
    (let (folder-node-list folder-name)
      (maphash
       #'(lambda (folder-name folder-node) (push folder-node folder-node-list))
       outline-tree2::*outline-tree-folder-hash*)
      (dolist (folder-node folder-node-list)
        (setq folder-name (outline-tree-data-get-folder-name folder-node))
        (treeview::treeview-set-item-text
         folder-node
         (if (and (integerp length) (plusp length))
             (abbreviate-display-string folder-name length t)
           folder-name))))))
(defun outline-tree-sort-folder-node ()
  "tH_m[htH_m[hŃ\[gB
outline-tree-insert-folder-node ֐ŎgpB"
  (treeview::with-app (*outline-tree-app-id*)
    (let (folder-node-cell-list node (i 0))
      (setq node (outline-tree-revdata-get-category-node
                  *outline-tree-invisible-buffer-category-node-name*))
      (when (outline-tree-node-valid-p node)
        (treeview::treeview-set-item-data node (incf i)))
      (setq node (outline-tree-revdata-get-category-node
                  *outline-tree-visible-buffer-category-node-name*))
      (when (outline-tree-node-valid-p node)
        (treeview::treeview-set-item-data node (incf i)))
      (maphash
       #'(lambda (folder-name folder-node) (push (cons folder-name folder-node) folder-node-cell-list))
       outline-tree2::*outline-tree-folder-hash*)
      (setq folder-node-cell-list (stable-sort folder-node-cell-list #'string-lessp :key #'car))
      (dolist (folder-node-cell folder-node-cell-list)
        (setq node (cdr folder-node-cell))
        (treeview::treeview-set-item-data node (incf i)))
      (treeview::treeview-sort-children-cb-lparam-ascending winapi::TVI_ROOT))))
(defun outline-tree-insert-folder-node (folder-name parent-node &key (insertafter winapi:TVI_SORT)
                                                                     implicit-func explicit-func)
  "tH_m[hǉB
insertafter ̓C^[tF[X̂߂ɑ݂邪B"
  (treeview::with-app (*outline-tree-app-id*)
    (prog1
        (outline-tree-register-folder-node
         folder-name
         (treeview::treeview-insert-item
          (if (and (integerp *outline-tree-abbreviate-display-folder-name-length*)
                   (plusp *outline-tree-abbreviate-display-folder-name-length*))
              (abbreviate-display-string folder-name
                                         *outline-tree-abbreviate-display-folder-name-length*
                                         t)
            folder-name)
          parent-node
          :insertafter insertafter
          :icon *outline-tree-icon-id-folder*
          :sicon *outline-tree-icon-id-folder*)
         :implicit-func implicit-func
         :explicit-func explicit-func)
      (outline-tree-sort-folder-node))))
(defun outline-tree-insert-category-node (category-name parent-node &key (insertafter winapi:TVI_SORT)
                                                                         implicit-func explicit-func)
  (treeview::with-app (*outline-tree-app-id*)
    (outline-tree-register-category-node
     category-name
     (treeview::treeview-insert-item category-name parent-node
                                     :insertafter insertafter
                                     :icon *outline-tree-icon-id-category*
                                     :sicon *outline-tree-icon-id-category*)
     :implicit-func implicit-func
     :explicit-func explicit-func)))

(defvar *outline-tree-update-modified-buffer-node-name-view-p* t)
(defun outline-tree-update-modified-buffer-node-name-view ()
  (unless *outline-tree-update-modified-buffer-node-name-view-p*
    (return-from outline-tree-update-modified-buffer-node-name-view nil))
  (treeview::with-app (*outline-tree-app-id*)
    (let (buffer-node-name-view)
      (maphash
       #'(lambda (buffer buffer-node)
           (setq buffer-node-name-view
                 (if (buffer-modified-p buffer)
                     (concat "* " (outline-tree-data-get-node-name buffer-node))
                   (outline-tree-data-get-node-name buffer-node)))
           (unless (string-equal buffer-node-name-view
                                 (treeview::treeview-get-item-text buffer-node))
             (treeview::treeview-set-item-text buffer-node buffer-node-name-view)))
       outline-tree2::*outline-tree-buffer-hash*))))
(add-hook 'ed::*post-command-hook* 'outline-tree-update-modified-buffer-node-name-view)
(defun outline-tree-sort-node (parent-node)
  "w肵 parent-node ̎qm[hm[hŃ\[gB
outline-tree-insert-buffer-node ֐ŎgpB"
  (treeview::with-app (*outline-tree-app-id*)
    (let (node node-cell-list (i 0))
      (setq node (treeview::treeview-get-child-item parent-node))
      (while (outline-tree-node-valid-p node)
        (push (cons (outline-tree-data-get-node-name node) node) node-cell-list)
        (setq node (treeview::treeview-get-next-sibling-item node)))
      (setq node-cell-list (stable-sort node-cell-list #'string< :key #'car))
      (dolist (node-cell node-cell-list)
        (setq node (cdr node-cell))
        (treeview::treeview-set-item-data node (incf i)))
      (treeview::treeview-sort-children-cb-lparam-ascending parent-node))))
(defun outline-tree-insert-buffer-node (buffer parent-node &key (insertafter winapi:TVI_SORT)
                                                                implicit-func explicit-func)
  (treeview::with-app (*outline-tree-app-id*)
    (let* ((buffer-name (buffer-name buffer))
           (namestring (get-buffer-file-name buffer))
           (file-name (and namestring (file-namestring namestring))))
      (prog1
          (outline-tree-register-buffer-node
           buffer
           (if namestring
               (treeview::treeview-insert-item file-name parent-node
                                               :insertafter insertafter
                                               :icon *outline-tree-icon-id-file*
                                               :sicon *outline-tree-icon-id-file*)
             (treeview::treeview-insert-item buffer-name parent-node
                                             :insertafter insertafter
                                             :icon *outline-tree-icon-id-buffer*
                                             :sicon *outline-tree-icon-id-buffer*))
           :buffer-name buffer-name
           :namestring namestring
           :implicit-func implicit-func
           :explicit-func explicit-func)
        (outline-tree-sort-node parent-node)))))

(defvar *outline-tree-range-node-group-p* nil
  "pB
outline-tree-insert-range-node ֐ŕ]B
outline-tree-create-outline-range-internal ֐ɂĈꎞIɒlݒ肳B")
(defun outline-tree-insert-range-node (range-name parent-node
                                       &key (insertafter winapi:TVI_LAST)
                                            title-range whole-range sub-type
                                            implicit-func explicit-func)
  (let (icon group-count)
    (cond ((eq sub-type :header-node)
           (setq icon *outline-tree-icon-id-header*))
          ((and *outline-tree-range-node-group-p*
                (plusp (setq group-count (outline-tree-data-get-group-count parent-node))))
           (cond ((eq sub-type :heading-node)
                  (cond ((= (mod group-count 2) 1)
                         (setq icon *outline-tree-icon-id-heading1*))
                        ((= (mod group-count 2) 0)
                         (setq icon *outline-tree-icon-id-heading2*))))
                 (t
                  (cond ((= (mod group-count 2) 1)
                         (setq icon *outline-tree-icon-id-range1*))
                        ((= (mod group-count 2) 0)
                         (setq icon *outline-tree-icon-id-range2*))))))
          (t
           (cond ((eq sub-type :heading-node)
                  (setq icon *outline-tree-icon-id-heading*))
                 (t
                  (setq icon *outline-tree-icon-id-range*)))))
    (treeview::with-app (*outline-tree-app-id*)
      (outline-tree-register-range-node
       range-name
       (treeview::treeview-insert-item range-name parent-node
                                       :insertafter insertafter
                                       :icon icon :sicon icon)
       :title-range title-range
       :whole-range whole-range
       :sub-type sub-type
       :implicit-func implicit-func
       :explicit-func explicit-func))))
(defun outline-tree-insert-point-node (point-name parent-node &key (insertafter winapi:TVI_LAST)
                                                                   point
                                                                   implicit-func explicit-func)
  (treeview::with-app (*outline-tree-app-id*)
    (outline-tree-register-point-node
     point-name
     (treeview::treeview-insert-item point-name parent-node
                                     :insertafter insertafter
                                     :icon *outline-tree-icon-id-point*
                                     :sicon *outline-tree-icon-id-point*)
     :point point
     :implicit-func implicit-func
     :explicit-func explicit-func)))
(defun outline-tree-insert-info-node (info-name parent-node &key (insertafter winapi:TVI_LAST)
                                                                 implicit-func explicit-func)
  (treeview::with-app (*outline-tree-app-id*)
    (outline-tree-register-info-node
     info-name
     (treeview::treeview-insert-item info-name parent-node
                                     :insertafter insertafter
                                     :icon *outline-tree-icon-id-info*
                                     :sicon *outline-tree-icon-id-info*)
     :implicit-func implicit-func
     :explicit-func explicit-func)))
(defun outline-tree-insert-section-node (section-name parent-node &key (insertafter winapi:TVI_LAST)
                                                                       implicit-func explicit-func)
  (treeview::with-app (*outline-tree-app-id*)
    (outline-tree-register-section-node
     section-name
     (treeview::treeview-insert-item section-name parent-node
                                     :insertafter insertafter
                                     :icon *outline-tree-icon-id-section*
                                     :sicon *outline-tree-icon-id-section*)
     :implicit-func implicit-func
     :explicit-func explicit-func)))

;;----------------------------------------------------------------------------
;; m[h(P)폜
;;----------------------------------------------------------------------------
(defun outline-tree-remove-node-tree (node)
  (treeview::treeview-funcall-recursive-tree-bottom-up
   node #'outline-tree-remove-node))
(defun outline-tree-remove-node (node)
  (case (outline-tree-data-get-type node)
    (:range-node
     (outline-tree-remove-range-node node))
    (:point-node
     (outline-tree-remove-point-node node))
    (:buffer-node
     (outline-tree-remove-buffer-node node))
    (:folder-node
     (outline-tree-remove-folder-node node))
    (:category-node
     (outline-tree-remove-category-node node))
    (:info-node
     (outline-tree-remove-info-node node))
    (:section-node
     (outline-tree-remove-section-node node)))
  t)
(defun outline-tree-remove-range-node (node)
  (treeview::with-app (*outline-tree-app-id*)
    (outline-tree-unregister-range-node node)
    (treeview::treeview-delete-item node)))
(defun outline-tree-remove-point-node (node)
  (treeview::with-app (*outline-tree-app-id*)
    (outline-tree-unregister-point-node node)
    (treeview::treeview-delete-item node)))
(defun outline-tree-remove-buffer-node (node)
  (treeview::with-app (*outline-tree-app-id*)
    (outline-tree-unregister-buffer-node node)
    (treeview::treeview-delete-item node)))
(defun outline-tree-remove-folder-node (node)
  (treeview::with-app (*outline-tree-app-id*)
    (outline-tree-unregister-folder-node node)
    (treeview::treeview-delete-item node)))
(defun outline-tree-remove-category-node (node)
  (treeview::with-app (*outline-tree-app-id*)
    (outline-tree-unregister-category-node node)
    (treeview::treeview-delete-item node)))
(defun outline-tree-remove-info-node (node)
  (treeview::with-app (*outline-tree-app-id*)
    (outline-tree-unregister-info-node node)
    (treeview::treeview-delete-item node)))
(defun outline-tree-remove-section-node (node)
  (treeview::with-app (*outline-tree-app-id*)
    (outline-tree-unregister-section-node node)
    (treeview::treeview-delete-item node)))

;;----------------------------------------------------------------------------
;; window/node -> buffer ł̊֐Ăяo
;;----------------------------------------------------------------------------
(defun outline-tree-funcall-buffer-by-window (func window)
  (unless window
    (setq window (outline-tree-get-target-window)))
  (let ((gcolumn (goal-column)))
    (prog1
        (save-window-excursion
          (set-window window)
          (funcall func (selected-buffer)))
      (set-goal-column gcolumn))))
(defun outline-tree-funcall-buffer-by-node (func node)
  (treeview::with-app (*outline-tree-app-id*)
    (unless node
      (setq node (outline-tree-get-selected-node)))
    (let (buffer)
      (when (and (outline-tree-node-valid-p node)
                 (setq buffer (outline-tree-get-buffer-by-node node)))
        (funcall func buffer)))))

;;----------------------------------------------------------------------------
;; contents-range ̐ݒ
;;    contents-range Ƃ́H:
;;      
;;----------------------------------------------------------------------------
(defun outline-tree-set-data-contents-range-tree (arg)
  (case (type-of arg)
    (integer ; node
     (outline-tree-set-data-contents-range-tree-by-node arg))
    (buffer
     (outline-tree-set-data-contents-range-tree-by-buffer arg))
    (window
     (outline-tree-set-data-contents-range-tree-by-window arg))))
(defun outline-tree-set-data-contents-range-tree-by-node (&optional node)
  (treeview::with-app (*outline-tree-app-id*)
    (unless node
      (setq node (outline-tree-get-selected-node)))
    (setq node (outline-tree-get-buffer-node-by-node node))
    (unless node
      (return-from outline-tree-set-data-contents-range-tree-by-node))
    (let ((line-oriented-p
           (member :line-oriented (outline-tree-get-create-outline-function-type
                                   (outline-tree-get-create-outline-function-by-node node)))))
      (save-excursion
        (save-restriction
          (set-buffer (outline-tree-get-buffer-by-node node))
          (widen)
          (treeview::treeview-funcall-recursive-subtree-top-down
           node
           #'(lambda (heading-node)
               ;; m[h heading-node ŁA܂ contents-range ݒ肳ĂȂꍇ
               (when (and (outline-tree-heading-node-p heading-node)
                          (not (outline-tree-data-get-contents-range heading-node)))
                 (let ((range (outline-tree-data-get-whole-range heading-node))
                       (title-range (outline-tree-data-get-title-range heading-node))
                       child-node)
                   ;; o͔͈͂A^Cg͈̔͂̏B
                   ;; ݂̓^CgS͈͂̐擪ɂꍇlĂȂB
                   (setq range (outline-tree-range-narrow
                                range
                                (progn
                                  (goto-char (cdr title-range))
                                  (when line-oriented-p
                                    (goto-eol)
                                    (forward-char))
                                  (point))
                                nil))
                   ;; qm[hꍇ
                   (when (outline-tree-node-has-children-p heading-node)
                     (setq child-node (treeview::treeview-get-child-item heading-node))
                     (while (outline-tree-node-valid-p child-node)
                       (when (outline-tree-heading-node-p child-node)
                         ;; o͔͈͂Aqm[h͈̔͂B
                         ;; ݂͎qm[hem[h̖ɂꍇlĂȂB
                         (setq range (outline-tree-range-narrow
                                      range
                                      nil
                                      (car (outline-tree-data-get-whole-range child-node)))))
                       (setq child-node (treeview::treeview-get-next-sibling-item child-node))))
                   (outline-tree-update-range-node heading-node :contents-range range))))))))
    t))
(defun outline-tree-set-data-contents-range-tree-by-buffer (&optional buffer)
  (unless buffer
    (setq buffer (outline-tree-get-target-buffer)))
  (let ((buffer-node (outline-tree-get-buffer-node-by-buffer buffer)))
    (when buffer-node
      (outline-tree-set-data-contents-range-tree-by-node buffer-node))))
(defun outline-tree-set-data-contents-range-tree-by-window (&optional window)
  (outline-tree-funcall-buffer-by-window
   #'outline-tree-set-data-contents-range-tree-by-buffer window))

;;----------------------------------------------------------------------------
;; output-range ̐ݒ
;;   output-range Ƃ́H:
;;     heading-node ̏o͔͈͂ƂĐݒ肷ú͈vB
;;     S͈͂Am[h̃^Cg͈̔́Aqm[h͈̔͂B
;;----------------------------------------------------------------------------
(defun outline-tree-set-data-output-range-tree (arg)
  (case (type-of arg)
    (integer ; node
     (outline-tree-set-data-output-range-tree-by-node arg))
    (buffer
     (outline-tree-set-data-output-range-tree-by-buffer arg))
    (window
     (outline-tree-set-data-output-range-tree-by-window arg))))
(defun outline-tree-set-data-output-range-tree-by-node (&optional node)
  (treeview::with-app (*outline-tree-app-id*)
    (unless node
      (setq node (outline-tree-get-selected-node)))
    (setq node (outline-tree-get-buffer-node-by-node node))
    (unless node
      (return-from outline-tree-set-data-output-range-tree-by-node))
    (let ((line-oriented-p
           (member :line-oriented (outline-tree-get-create-outline-function-type
                                   (outline-tree-get-create-outline-function-by-node node)))))
      (save-excursion
        (save-restriction
          (set-buffer (outline-tree-get-buffer-by-node node))
          (widen)
          (treeview::treeview-funcall-recursive-subtree-top-down
           node
           #'(lambda (heading-node)
               ;; m[h \ĂāAheading-node ̏ꍇ
               (when (and (treeview::treeview-item-visible-p heading-node)
                          (outline-tree-heading-node-p heading-node))
                 (let ((range (outline-tree-data-get-whole-range heading-node))
                       (title-range (outline-tree-data-get-title-range heading-node))
                       child-node)
                   ;; o͔͈͂A^Cg͈̔͂̏B
                   ;; ݂̓^CgS͈͂̐擪ɂꍇlĂȂB
                   (setq range (outline-tree-range-narrow
                                range
                                (progn
                                  (goto-char (cdr title-range))
                                  (when line-oriented-p
                                    (goto-eol)
                                    (forward-char))
                                  (point))
                                nil))
                   ;; m[h̎qm[h\Ăꍇ
                   (when (and (outline-tree-node-has-children-p heading-node)
                              (treeview::treeview-expand-p heading-node))
                     (setq child-node (treeview::treeview-get-child-item heading-node))
                     (while (outline-tree-node-valid-p child-node)
                       (when (outline-tree-heading-node-p child-node)
                         ;; o͔͈͂Aqm[h͈̔͂B
                         ;; ݂͎qm[hem[h̖ɂꍇlĂȂB
                         (setq range (outline-tree-range-narrow
                                      range
                                      nil
                                      (car (outline-tree-data-get-whole-range child-node)))))
                       (setq child-node (treeview::treeview-get-next-sibling-item child-node))))
                   (outline-tree-data-set-output-range heading-node range))))))))
    t))
(defun outline-tree-set-data-output-range-tree-by-buffer (&optional buffer)
  (unless buffer
    (setq buffer (outline-tree-get-target-buffer)))
  (let ((buffer-node (outline-tree-get-buffer-node-by-buffer buffer)))
    (when buffer-node
      (outline-tree-set-data-output-range-tree-by-node buffer-node))))
(defun outline-tree-set-data-output-range-tree-by-window (&optional window)
  (outline-tree-funcall-buffer-by-window
   #'outline-tree-set-data-output-range-tree-by-buffer window))

;;----------------------------------------------------------------------------
;; obt@m[h̍쐬
;;----------------------------------------------------------------------------
(defun outline-tree-create-buffer-node (&optional arg)
  (case (type-of arg)
    (buffer
     (outline-tree-create-buffer-node-by-buffer arg))
    (window
     (outline-tree-create-buffer-node-by-window arg))
    (integer ; node
     (outline-tree-create-buffer-node-by-node arg))))
(defun outline-tree-create-buffer-node-by-buffer (&optional buffer)
  (interactive)
  "obt@ɑΉm[h̍쐬/XV"
  (unless buffer
    (setq buffer (outline-tree-get-target-buffer)))
  (treeview::with-app (*outline-tree-app-id*)
    (unless (outline-tree-exist-p)
      (return-from outline-tree-create-buffer-node-by-buffer))
    (cond
     ((listp buffer)
      (dolist (x buffer)
        (outline-tree-create-buffer-node-by-buffer x)))
     ((bufferp buffer)
      ;;  buffer-node `FbN
      (let ((buffer-node (outline-tree-get-buffer-node-by-buffer buffer)))
        (if buffer-node
            (if (outline-tree-buffer-node-obsolete-p buffer-node)
                ;; Â buffer-node 폜
                (outline-tree-delete-buffer-node-by-buffer buffer)
              ;; ŐV buffer-node ̏ꍇ͏I
              (return-from outline-tree-create-buffer-node-by-buffer))))
      ;; o^
      (when (not (deleted-buffer-p buffer))
        (let* ((buffer-name (buffer-name buffer))
               (namestring (get-buffer-file-name buffer))
               (folder-name (namestring
                             (or (and namestring
                                      (truename (directory-namestring namestring)))
                                 (default-directory buffer))))
               (visible-buffer-p (not (string-match "^ " buffer-name)))
               folder-node buffer-node category-name category-node
               parent-node)
          (cond
           ;; file
           (namestring
            (setq folder-node (outline-tree-get-folder-node-by-folder-name folder-name))
            (unless folder-node
              (setq folder-node (outline-tree-insert-folder-node folder-name winapi:TVI_ROOT)))
            (setq parent-node folder-node))
           ;; visible/invisible buffer
           (t
            ;; category o^
            (if visible-buffer-p
                (setq category-name *outline-tree-visible-buffer-category-node-name*)
              (setq category-name *outline-tree-invisible-buffer-category-node-name*))
            (unless (setq category-node (outline-tree-revdata-get-category-node category-name))
              (setq category-node (outline-tree-insert-category-node category-name winapi:TVI_ROOT)))
            (setq parent-node category-node)
            ;; sub category () o^
            (when (setq category-name (outline-tree-detect-category-name buffer-name))
              (unless (setq category-node
                            (outline-tree-revdata-get-category-node category-name parent-node))
                (setq category-node (outline-tree-insert-category-node category-name parent-node)))
              (setq parent-node category-node))))
          (setq buffer-node (outline-tree-insert-buffer-node buffer parent-node))
          (save-excursion
            (save-window-excursion
              (when (minibuffer-window-p (selected-window))
                (other-window))
              (set-buffer buffer)
              (setq outline-tree-outline-modified nil)))
          (when (or namestring visible-buffer-p)
            (treeview::treeview-expand-expand parent-node))
          (unless (outline-tree-node-valid-p (outline-tree-get-selected-node))
            (outline-tree-select-node-by-buffer buffer))))))))
(defun outline-tree-create-buffer-node-by-window (&optional window)
  (interactive)
  (outline-tree-funcall-buffer-by-window
   #'outline-tree-create-buffer-node-by-buffer window))
(defun outline-tree-create-buffer-node-by-node (&optional node)
  (interactive)
  (outline-tree-funcall-buffer-by-node
   #'outline-tree-create-buffer-node-by-buffer node))

(defun outline-tree-buffer-node-obsolete-p (buffer-node)
  "obt@m[hŐV̏ԂłȂƂ̔
outline-tree-create-buffer-node-by-buffer ŗp⏕֐"
  (let* ((buffer-name (outline-tree-data-get-buffer-name buffer-node))
         (namestring (outline-tree-data-get-namestring buffer-node))
         (buffer (outline-tree-data-get-buffer buffer-node))
         (current-buffer-name (buffer-name buffer))
         (current-namestring (get-buffer-file-name buffer)))
    (or (not buffer)
        (and namestring (not (equalp namestring current-namestring)))
        (and (not namestring) (not (equal buffer-name current-buffer-name))))))

;;----------------------------------------------------------------------------
;; obt@m[h̍폜
;;----------------------------------------------------------------------------
(defvar *outline-tree-delete-buffer-node-kill-xyzzy-command-list*
  '(ed::kill-xyzzy)
  "ed::*this-command* XgɎw肳Ăꍇ
outline-tree-delete-buffer-node-by-buffer ͏s킸ɏIB")
(defun outline-tree-delete-buffer-node (&optional arg)
  (case (type-of arg)
    (buffer
     (outline-tree-delete-buffer-node-by-buffer arg))
    (window
     (outline-tree-delete-buffer-node-by-window arg))
    (integer ; node
     (outline-tree-delete-buffer-node-by-node arg))))
(defun outline-tree-delete-buffer-node-by-buffer (&optional buffer)
  (interactive)
  "obt@ɑΉm[h폜"
  (when (member ed::*this-command* *outline-tree-delete-buffer-node-kill-xyzzy-command-list*)
    (return-from outline-tree-delete-buffer-node-by-buffer t))
  (unless buffer
    (setq buffer (outline-tree-get-target-buffer)))
  (treeview::with-app (*outline-tree-app-id*)
    (unless (outline-tree-exist-p)
      (return-from outline-tree-delete-buffer-node-by-buffer t))
    (cond
     ((listp buffer)
      (dolist (x buffer)
        (outline-tree-delete-buffer-node-by-buffer x)))
     ((bufferp buffer)
      (let* ((buffer-node (outline-tree-get-buffer-node-by-buffer buffer))
             (node buffer-node) parent-node parent-node-list)
        (when (outline-tree-node-valid-p buffer-node)
          (while (and (outline-tree-node-valid-p
                       (setq parent-node (treeview::treeview-get-parent-item node)))
                      (not (outline-tree-node-valid-p
                            (treeview::treeview-get-next-sibling-item
                             (treeview::treeview-get-child-item parent-node)))))
            (push parent-node parent-node-list)
            (setq node parent-node))
          (outline-tree-remove-buffer-node buffer-node)
          (dolist (parent-node (nreverse parent-node-list))
            (case (outline-tree-data-get-type parent-node)
              (:folder-node
               (outline-tree-remove-folder-node parent-node))
              (:category-node
               (outline-tree-remove-category-node parent-node))))))
      (run-hook-with-args '*outline-tree-delete-buffer-node-hook* buffer))))
  t)
(defun outline-tree-delete-buffer-node-by-window (&optional window)
  (interactive)
  (outline-tree-funcall-buffer-by-window
   #'outline-tree-delete-buffer-node-by-buffer window))
(defun outline-tree-delete-buffer-node-by-node (&optional node)
  (interactive)
  (outline-tree-funcall-buffer-by-node
   #'outline-tree-delete-buffer-node-by-buffer node))

;;----------------------------------------------------------------------------
;; TuJeSo
;;----------------------------------------------------------------------------
(defun outline-tree-detect-category-name (name)
  "name  category ނAމ\̏ꍇ category Ԃ"
  (let (category-name)
    (dolist (category-regexp *outline-tree-buffer-category-regexp-list*
                             (setq category-name nil))
      (setq category-name nil)
      (when (listp category-regexp)
        (setq category-name (cdr category-regexp))
        (setq category-regexp (car category-regexp)))
      (when (string-match category-regexp name)
        (unless category-name
          (setq category-name (concat " " (match-string 1))))
        (return)))
    category-name))

;;----------------------------------------------------------------------------
;; AEgC̍쐬֐̎擾
;;----------------------------------------------------------------------------
(defvar-local outline-tree-create-outline-function-interactive nil
  "ΘbIɃ[UɂĐݒ肳AEgC쐬֐(ŗD)")
(defvar-local outline-tree-create-outline-function nil
  "ʓIɃ[U mode hook Őݒ肷AEgC쐬֐(Dx3)")
(defvar *outline-tree-get-default-create-outline-function*
  'outline-tree-get-default-create-outline-function)

(defun outline-tree-get-create-outline-function (&optional arg)
  (case (type-of arg)
    (buffer
     (outline-tree-get-create-outline-function-by-buffer arg))
    (window
     (outline-tree-get-create-outline-function-by-window arg))
    (integer ; node
     (outline-tree-get-create-outline-function-by-node arg))))
(defun outline-tree-get-create-outline-function-by-buffer (&optional buffer)
  (interactive)
  (treeview::with-app (*outline-tree-app-id*)
    (unless buffer
      (setq buffer (outline-tree-get-target-buffer)))
    (save-excursion
      (unless (eq buffer (selected-buffer))
        (set-buffer buffer))
      (let (func)
        (cond (outline-tree-create-outline-function-interactive
               outline-tree-create-outline-function-interactive)
              ((setq func (outline-tree-create-get-outline-function-auto-mode))
               func)
              (outline-tree-create-outline-function
               outline-tree-create-outline-function)
              (*outline-tree-get-default-create-outline-function*
               (funcall *outline-tree-get-default-create-outline-function* buffer)))))))
(defun outline-tree-get-create-outline-function-by-window (&optional window)
  (interactive)
  (outline-tree-funcall-buffer-by-window
   #'outline-tree-get-create-outline-function-by-buffer window))
(defun outline-tree-get-create-outline-function-by-node (&optional node)
  (interactive)
  (outline-tree-funcall-buffer-by-node
   #'outline-tree-get-create-outline-function-by-buffer node))

;;----------------------------------------------------------------------------
;; AEgC쐬֐ auto-mode-parameter 擾
;;----------------------------------------------------------------------------
(defvar *outline-tree-find-file-outline-create-function-alist* nil)
(push '("outline-tree" . outline-tree-find-file-outline-create-function)
      ed::*auto-mode-parameter-alist*)
(defun outline-tree-find-file-outline-create-function (string)
  (let ((package (find-package "outline-tree2"))
        (function-list (mapcar #'car *outline-tree-create-outline-function-alist*))
        function-symbol function-alist)
    (when (or (and (setq function-symbol (find-symbol string package))
                   (find function-symbol function-list))
              (and (setq function-symbol (find-symbol (concat "outline-tree-create-outline-" string) package))
                   (find function-symbol function-list))
              (and (setq function-symbol (find-symbol (concat "outline-tree-create-outline-" (string-downcase string)) package))
                   (find function-symbol function-list)))
      (dolist (x *outline-tree-find-file-outline-create-function-alist*)
        (unless (deleted-buffer-p (car x))
          (push x function-alist)))
      (setq *outline-tree-find-file-outline-create-function-alist*
            (nreverse function-alist))
      (push (cons (selected-buffer) function-symbol)
            *outline-tree-find-file-outline-create-function-alist*)
      t)))
(defun outline-tree-create-get-outline-function-auto-mode (&optional buffer)
  (unless buffer
    (setq buffer (selected-buffer)))
  (cdr (find buffer *outline-tree-find-file-outline-create-function-alist*
             :key #'car)))

;;----------------------------------------------------------------------------
;; AEgC̍쐬֐̎擾
;;----------------------------------------------------------------------------
(defun outline-tree-get-create-outline-function-all-info (func-symbol)
  (find func-symbol *outline-tree-create-outline-function-alist* :key #'car))
(defun outline-tree-get-create-outline-function-name (func-symbol)
  (let* ((all-info (outline-tree-get-create-outline-function-all-info func-symbol))
         (func-name (second all-info)) (func-type (third all-info))
         (func-doc (fourth all-info)))
    func-name))
(defun outline-tree-get-create-outline-function-type (func-symbol)
  (let* ((all-info (outline-tree-get-create-outline-function-all-info func-symbol))
         (func-name (second all-info)) (func-type (third all-info))
         (func-doc (fourth all-info)))
    func-type))
(defun outline-tree-get-create-outline-function-doc (func-symbol)
  (let* ((all-info (outline-tree-get-create-outline-function-all-info func-symbol))
         (func-name (second all-info)) (func-type (third all-info))
         (func-doc (fourth all-info)))
    func-doc))

;;----------------------------------------------------------------------------
;; AEgC̍쐬
;;----------------------------------------------------------------------------
(defun outline-tree-create-outline (&optional arg)
  (interactive)
  (case (type-of arg)
    (buffer
     (outline-tree-create-outline-by-buffer arg))
    (window
     (outline-tree-create-outline-by-window arg))
    (integer ; node
     (outline-tree-create-outline-by-node arg))
    (t
     (outline-tree-create-outline-by-window))))
(defun outline-tree-create-outline-by-buffer (&optional buffer)
  (interactive)
  (unless (outline-tree-exist-p)
    (outline-tree-create))
  (treeview::with-app (*outline-tree-app-id*)
    (unless buffer
      (setq buffer (outline-tree-get-target-buffer)))
    (unless (listp buffer)
      (setq buffer (list buffer)))
    (unless (outline-tree-exist-p)
      (outline-tree-create))
    (unless (outline-tree-open-p)
      (outline-tree-open))
    (save-excursion
      (let ((buffer-list buffer) buffer-node create-outline-function)
        (dolist (buffer buffer-list)
          (unless (eq buffer (selected-buffer))
            (set-buffer buffer))
          (save-restriction
            (widen)
            (setq buffer-node (outline-tree-get-buffer-node-by-buffer buffer))
            ;;  outline 폜
            (outline-tree-delete-outline buffer)
            ;; outline ̍쐬
            (when (setq create-outline-function
                        (outline-tree-get-create-outline-function-by-buffer buffer))
              (long-operation
                (funcall create-outline-function buffer-node)))
            ;; 쐬̃m[hWJ
            (treeview::treeview-expand-expand
             buffer-node :child t :visible nil
             :depth (if (eq *outline-tree-expand-on-create-outline* :depth)
                        *outline-tree-expand-depth-on-create-outline*
                      *outline-tree-expand-on-create-outline*))
            ;; ŐṼAEgCƔF悤ݒ
            (setq outline-tree-outline-modified (buffer-modified-count))))))
    (treeview::treeview-refresh-treeview)
    (refresh-screen)
    (run-hooks '*outline-tree-create-outline-hook*)))
(defun outline-tree-create-outline-by-window (&optional window)
  (interactive)
  (outline-tree-funcall-buffer-by-window
   #'outline-tree-create-outline-by-buffer window))
(defun outline-tree-create-outline-by-node (&optional node)
  (interactive)
  (outline-tree-funcall-buffer-by-node
   #'outline-tree-create-outline-by-buffer node))

;;----------------------------------------------------------------------------
;; AEgC̍폜
;;----------------------------------------------------------------------------
(defun outline-tree-delete-outline (&optional arg)
  (case (type-of arg)
    (integer ; node
     (outline-tree-delete-outline-by-node arg))
    (window
     (outline-tree-delete-outline-by-window arg))
    (buffer
     (outline-tree-delete-outline-by-buffer arg))))
(defun outline-tree-delete-outline-by-buffer (&optional buffer)
  (interactive)
  (unless buffer
    (setq buffer (outline-tree-get-target-buffer)))
  (treeview::with-app (*outline-tree-app-id*)
    (unless (outline-tree-exist-outline-p buffer)
      (return-from outline-tree-delete-outline-by-buffer))
    (save-excursion
      (set-buffer buffer)
      (setq outline-tree-outline-modified nil))
    (let ((buffer-node (outline-tree-get-buffer-node-by-buffer buffer)) node)
      (when buffer-node
        (treeview::treeview-expand-collapse buffer-node)
        (treeview::treeview-funcall-recursive-subtree-bottom-up
         buffer-node #'outline-tree-remove-node)
        (outline-tree-update-node buffer-node :group-count 0)))))
(defun outline-tree-delete-outline-by-window (&optional window)
  (interactive)
  (outline-tree-funcall-buffer-by-window
   #'outline-tree-delete-outline-by-buffer window))
(defun outline-tree-delete-outline-by-node (&optional node)
  (interactive)
  (outline-tree-funcall-buffer-by-node
   #'outline-tree-delete-outline-by-buffer node))

;;----------------------------------------------------------------------------
;; AEgC̑݊mF
;;----------------------------------------------------------------------------
(defvar-local outline-tree-outline-modified nil)
(defun outline-tree-exist-outline-p (&optional arg)
  (case (type-of arg)
    (buffer
     (outline-tree-exist-outline-p-by-buffer arg))
    (window
     (outline-tree-exist-outline-p-by-window arg)
    (integer ; node
     (outline-tree-exist-outline-p-by-node arg)))))
(defun outline-tree-exist-outline-p-by-buffer (&optional buffer)
  (unless buffer
    (setq buffer (outline-tree-get-target-buffer)))
  (treeview::with-app (*outline-tree-app-id*)
    (let ((buffer-node (outline-tree-get-buffer-node-by-buffer buffer)))
      (and (outline-tree-node-valid-p buffer-node)
           (outline-tree-node-has-children-p buffer-node)))))
(defun outline-tree-exist-outline-p-by-window (&optional window)
  (outline-tree-funcall-buffer-by-window
   #'outline-tree-exist-outline-p-by-buffer window))
(defun outline-tree-exist-outline-p-by-node (&optional node)
  (outline-tree-funcall-buffer-by-node
   #'outline-tree-exist-outline-p-by-buffer node))

;;----------------------------------------------------------------------------
;; AEgC̍ŐVmF
;;----------------------------------------------------------------------------
(defun outline-tree-latest-outline-p (&optional arg)
  (case (type-of arg)
    (buffer
     (outline-tree-latest-outline-p-by-buffer arg))
    (window
     (outline-tree-latest-outline-p-by-window arg))
    (integer ; node
     (outline-tree-latest-outline-p-by-node arg))
    (t
     (outline-tree-latest-outline-p-by-window))))
(defun outline-tree-latest-outline-p-by-buffer (&optional buffer)
  (unless buffer
    (setq buffer (outline-tree-get-target-buffer)))
  (save-excursion
    (unless (eq buffer (selected-buffer))
      (set-buffer buffer))
    (and (outline-tree-exist-p)
         (eql outline-tree-outline-modified (buffer-modified-count)))))
(defun outline-tree-latest-outline-p-by-window (&optional window)
  (outline-tree-funcall-buffer-by-window
   #'outline-tree-latest-outline-p-by-buffer window))
(defun outline-tree-latest-outline-p-by-node (&optional node)
  (outline-tree-funcall-buffer-by-node
   #'outline-tree-latest-outline-p-by-buffer node))

;;----------------------------------------------------------------------------
;; [U`AEgCj[pϐ
;;----------------------------------------------------------------------------
(defvar *outline-tree-context-menu-node* nil
  "m[hΉj[쐬ɁAΏۃm[hێB
[U`j[łA*outline-tree-buffer-menu*,
*outline-tree-folder-menu* ŗp邱Ƃz")
(defvar *outline-tree-buffer-menu* nil
  "obt@m[hɑ΂郆[U`j[")
(defvar *outline-tree-folder-menu* nil
  "tH_m[hɑ΂郆[U`j[")

;;----------------------------------------------------------------------------
;; AEgCc[쐬⏕֐
;;----------------------------------------------------------------------------
(defun outline-tree-initialize-expand-node ()
  "m[h̊JԂԂɂ
ԁFtH_m[hWJ
          \obt@JeSm[hȊÕJeSm[hWJ
outline-tree-create ŗp⏕֐"
  (treeview::with-app (*outline-tree-app-id*)
    (unless (outline-tree-exist-p)
      (return-from outline-tree-initialize-expand-node))
    (let ((invisible-node
           (outline-tree-revdata-get-category-node
            *outline-tree-invisible-buffer-category-node-name* winapi:TVI_ROOT)))
      (treeview::treeview-map-item-tree
       (treeview::treeview-get-item-tree 0)
       #'(lambda (node)
           (case (outline-tree-data-get-type node)
             (:folder-node
              (treeview::treeview-expand-expand node))
             (:category-node
              (unless (find invisible-node
                            (treeview::treeview-get-ancestor-item-list node)
                            :test #'treeview::treeview-hitem-equal)
                (treeview::treeview-expand-expand node)))))))))

;;----------------------------------------------------------------------------
;; ΏۃEBhE
;;----------------------------------------------------------------------------
(defvar *outline-tree-target-window* nil
  "AEgCΏۃEBhE")
(defun outline-tree-define-target-window-popup-menu ()
  "AEgCΏۃEBhEI|bvAbvj["
  (let ((menu (create-popup-menu 'outline-tree-define-target-window))
        (window-list (mapcar 'car (caddr (current-window-configuration)))))
    (add-menu-item menu nil
                   "ANeBuEBhE"
                   #'(lambda () (interactive)
                       (setq *outline-tree-target-window* nil))
                   #'(lambda ()
                       (and (eq *outline-tree-target-window* nil) :check)))
    (add-menu-separator menu)
    (dolist (window window-list)
      (let ((window window))
        (add-menu-item menu window
                       (format nil "~A~S :: <~A>"
                               (if (eq window (selected-window)) "* " "  ")
                               window (buffer-name (window-buffer window)))
                       #'(lambda () (interactive)
                           (setq *outline-tree-target-window* window))
                       #'(lambda ()
                           (and (eq *outline-tree-target-window* window) :check)))))
    menu))

;;----------------------------------------------------------------------------
;; ΏۃEBhE/obt@̎擾
;;----------------------------------------------------------------------------
(defun outline-tree-get-target-window ()
  "Ώ window ̎擾 *outline-tree-target-window* ̍XV"
  (let ((window-list (mapcar 'car (caddr (current-window-configuration))))
        window)
    (if (and (windowp *outline-tree-target-window*)
             (not (minibuffer-window-p *outline-tree-target-window*))
             (member *outline-tree-target-window* window-list))
        (setq window *outline-tree-target-window*)
      (progn
        (setq *outline-tree-target-window* nil)
        (setq window (selected-window))))
    window))

(defun outline-tree-get-target-buffer ()
  "Ώ buffer ̎擾"
  (window-buffer (outline-tree-get-target-window)))

;;----------------------------------------------------------------------------
;; obt@̎擾
;;----------------------------------------------------------------------------
(defun outline-tree-get-buffer (arg)
  "̌^ɉAe@ buffer 擾Ԃ"
  (case (type-of arg)
    (integer ; node
     (outline-tree-get-buffer-by-node arg))))
(defun outline-tree-get-buffer-by-node (&optional node)
  "node  buffer Ԃ"
  (treeview::with-app (*outline-tree-app-id*)
    (unless node
      (setq node (outline-tree-get-selected-node)))
    (setq node (outline-tree-get-buffer-node-by-node node))
    (when node
      (outline-tree-data-get-buffer node))))

;;----------------------------------------------------------------------------
;; obt@m[h̎擾
;;----------------------------------------------------------------------------
(defun outline-tree-get-buffer-node (arg)
  "̌^ɉAe@ buffer-node 擾Ԃ"
  (case (type-of arg)
    (window
     (outline-tree-get-buffer-node-by-window arg))
    (buffer
     (outline-tree-get-buffer-node-by-buffer arg))
    (integer ; node
     (outline-tree-get-buffer-node-by-node arg))))
(defun outline-tree-get-buffer-node-by-node (&optional node)
  "node  buffer-node Ԃ"
  (treeview::with-app (*outline-tree-app-id*)
    (unless node
      (setq node (outline-tree-get-selected-node)))
    (loop
      (unless (outline-tree-node-valid-p node)
        (return-from outline-tree-get-buffer-node-by-node nil))
      (if (outline-tree-buffer-node-p node)
          (return-from outline-tree-get-buffer-node-by-node node)
        (setq node (treeview::treeview-get-parent-item node))))))
(defun outline-tree-get-buffer-node-by-buffer (&optional buffer)
  "buffer ɑΉ buffer-node Ԃ"
  (unless buffer
    (setq buffer (outline-tree-get-target-buffer)))
  (outline-tree-revdata-get-buffer-node buffer))
(defun outline-tree-get-buffer-node-by-window (&optional window)
  "window ɑΉ buffer-node Ԃ"
  (outline-tree-funcall-buffer-by-window
   #'outline-tree-get-buffer-node-by-buffer window))

;;----------------------------------------------------------------------------
;; tH_m[h̎擾
;;----------------------------------------------------------------------------
(defun outline-tree-get-folder-node (arg)
  "̌^ɉAe@ folder-node 擾Ԃ"
  (case (type-of arg)
    ((string simple-string) ; folder-name
     (outline-tree-get-folder-node-by-folder-name arg))
    (integer ; node
     (outline-tree-get-folder-node-by-node arg))
    (buffer
     (outline-tree-get-folder-node-by-buffer arg))
    (window
     (outline-tree-get-folder-node-by-window arg))))
(defun outline-tree-get-folder-node-by-folder-name (folder-name)
  "folder-name ɑΉ folder-node Ԃ"
  (outline-tree-revdata-get-folder-node folder-name))
(defun outline-tree-get-folder-node-by-node (&optional node)
  "node  folder-node Ԃ"
  (treeview::with-app (*outline-tree-app-id*)
    (unless node
      (setq node (outline-tree-get-selected-node)))
    (loop
      (unless (outline-tree-node-valid-p node)
        (return-from outline-tree-get-folder-node-by-node nil))
      (if (outline-tree-folder-node-p node)
          (return-from outline-tree-get-folder-node-by-node node)
        (setq node (treeview::treeview-get-parent-item node))))))
(defun outline-tree-get-folder-node-by-buffer (&optional buffer)
  "buffer ɑΉ folder-node Ԃ
buffer  (default-directory) ̔ł͂ȂAbuffer ɑΉ
buffer-node  TreeView ̊Kw\画肷B"
  (unless buffer
    (setq buffer (outline-tree-get-target-buffer)))
  (let ((buffer-node (outline-tree-get-buffer-node-by-buffer buffer)))
    (when buffer-node
      (outline-tree-get-folder-node-by-node buffer-node))))
(defun outline-tree-get-folder-node-by-window (&optional window)
  "window ɑΉ folder-node Ԃ"
  (outline-tree-funcall-buffer-by-window
   #'outline-tree-get-folder-node-by-buffer window))

;;----------------------------------------------------------------------------
;; tH_̎擾 ((default-directory) łȂ TreeView 擾)
;;----------------------------------------------------------------------------
(defun outline-tree-get-folder (arg)
  "̌^ɉAe@ folder 擾Ԃ"
  (case (type-of arg)
    (integer ; node
     (outline-tree-get-folder-node-by-node arg))
    (buffer
     (outline-tree-get-folder-node-by-buffer arg))
    (window
     (outline-tree-get-folder-node-by-window arg))))
(defun outline-tree-get-folder-by-node (&optional node)
  "node ɑΉ folder Ԃ"
  (let ((folder-node (outline-tree-get-folder-node-by-node node)))
    (when folder-node
      (outline-tree-data-get-folder-name folder-node))))
(defun outline-tree-get-folder-by-buffer (&optional buffer)
  "buffer ɑΉ folder Ԃ"
  (let ((folder-node (outline-tree-get-folder-node-by-buffer buffer)))
    (when folder-node
      (outline-tree-data-get-folder-name folder-node))))
(defun outline-tree-get-folder-by-window (&optional window)
  "window ɑΉ folder Ԃ"
  (let ((folder-node (outline-tree-get-folder-node-by-window window)))
    (when folder-node
      (outline-tree-data-get-folder-name folder-node))))

;;----------------------------------------------------------------------------
;; JeSm[h̎擾
;;----------------------------------------------------------------------------
(defun outline-tree-get-category-node (arg)
  "̌^ɉAe@ category-node 擾Ԃ"
  (case (type-of arg)
    (integer ; node
     (outline-tree-get-category-node-by-node arg))
    (buffer
     (outline-tree-get-category-node-by-buffer arg))
    (window
     (outline-tree-get-category-node-by-window arg))))
(defun outline-tree-get-category-node-by-node (&optional node)
  "node  category-node Ԃ"
  (treeview::with-app (*outline-tree-app-id*)
    (unless node
      (setq node (outline-tree-get-selected-node)))
    (loop
      (unless (outline-tree-node-valid-p node)
        (return-from outline-tree-get-category-node-by-node nil))
      (if (outline-tree-category-node-p node)
          (return-from outline-tree-get-category-node-by-node node)
        (setq node (treeview::treeview-get-parent-item node))))))
(defun outline-tree-get-category-node-by-buffer (&optional buffer)
  "buffer  category-node Ԃ"
  (unless buffer
    (setq buffer (outline-tree-get-target-buffer)))
  (let ((buffer-node (outline-tree-get-buffer-node-by-buffer buffer)))
    (when buffer-node
      (outline-tree-get-category-node-by-node buffer-node))))
(defun outline-tree-get-category-node-by-window (&optional window)
  "window  category-node Ԃ"
  (outline-tree-funcall-buffer-by-window
   #'outline-tree-get-category-node-by-buffer window))

;;----------------------------------------------------------------------------
;; m[h̎擾
;;----------------------------------------------------------------------------
(defun outline-tree-get-node (arg)
  "̌^ɉAe@ node 擾Ԃ"
  (case (type-of arg)
    (window
     (outline-tree-get-node-by-window arg))
    (buffer
     (outline-tree-get-node-by-buffer arg))))

;; 1.  ݂̃m[h`FbN
;; 2.1 ͈͂Ɋ܂܂ꍇ (m[hobt@m[h̏ꍇ܂)
;;       -> qm[hȉ𒲂ׁAYm[h΂A
;;          ȂΎm[hԂB
;; 2.2 ͈͂Ɋ܂܂Ȃꍇ
;;       -> em[hȉ(m[hȊO)`FbN
;; 2.3 ͈͂s̏ꍇ
;;       -> qm[hȉ𒲂ׁAYm[h΂A
;;          Ȃΐem[hȉ(m[hȊO)`FbN
;;
(defun outline-tree-get-node-by-buffer (&optional buffer)
  "buffer  point ɑΉ node Ԃ"
  (unless buffer
    (setq buffer (outline-tree-get-target-buffer)))
  (treeview::with-app (*outline-tree-app-id*)
    (let ((visible-buffer-p (not (string-match "^ " (buffer-name buffer))))
          (namestring (get-buffer-file-name buffer))
          (buffer-node (outline-tree-get-buffer-node-by-buffer buffer))
          (selected-node (outline-tree-get-selected-node))
          point)
      (unless (and buffer-node (or namestring visible-buffer-p))
        (return-from outline-tree-get-node-by-buffer nil))
      (labels (;; checked-node Amover-func Ŏ擾\ȑSĂ node ȉ`FbN
               (outline-tree-get-node-by-buffer-sub-tree-1 (node checked-node mover-func depth-from-buffer-node)
                 (let (whole-range child-node)
                   (while (outline-tree-node-valid-p node)
                     (when (treeview::treeview-hitem-not-equal node checked-node)
                       (case (outline-tree-data-get-type node)
                         ((:range-node)
                          (setq whole-range (outline-tree-data-get-whole-range node))
                          (when (eq (outline-tree-get-range-relation whole-range point) :inside)
                            (return-from outline-tree-get-node-by-buffer-sub-tree-1
                              (or (outline-tree-get-node-by-buffer-sub-tree
                                   node nil nil (1+ depth-from-buffer-node))
                                  node))))
                         (t
                          (when (setq child-node (outline-tree-get-node-by-buffer-sub-tree
                                                  node nil nil (1+ depth-from-buffer-node)))
                            (return-from outline-tree-get-node-by-buffer-sub-tree-1 child-node)))))
                     (setq node (funcall mover-func node)))))
               ;; checked-node ȉ̊KwO parent-node 艺̊KwŊYm[h擾
               (outline-tree-get-node-by-buffer-sub-tree (parent-node checked-node direction depth-from-buffer-node)
                 (unless (outline-tree-node-valid-p parent-node)
                   (return-from outline-tree-get-node-by-buffer-sub-tree nil))
                 (let (node)
                   (if checked-node
                       ;; checked-node w肳ĂꍇAparent-node  expand 
                       (cond
                        ((eq direction :less)
                         (when (setq node (outline-tree-get-node-by-buffer-sub-tree-1
                                           (treeview::treeview-get-prev-sibling-item checked-node)
                                           nil
                                           #'treeview::treeview-get-prev-sibling-item
                                           depth-from-buffer-node))
                           (return-from outline-tree-get-node-by-buffer-sub-tree node))
                         (when (setq node (outline-tree-get-node-by-buffer-sub-tree-1
                                           (treeview::treeview-get-next-sibling-item checked-node)
                                           nil
                                           #'treeview::treeview-get-next-sibling-item
                                           depth-from-buffer-node))
                           (return-from outline-tree-get-node-by-buffer-sub-tree node)))
                        ((eq direction :greater)
                         (when (setq node (outline-tree-get-node-by-buffer-sub-tree-1
                                           (treeview::treeview-get-next-sibling-item checked-node)
                                           nil
                                           #'treeview::treeview-get-next-sibling-item
                                           depth-from-buffer-node))
                           (return-from outline-tree-get-node-by-buffer-sub-tree node))
                         (when (setq node (outline-tree-get-node-by-buffer-sub-tree-1
                                           (treeview::treeview-get-prev-sibling-item checked-node)
                                           nil
                                           #'treeview::treeview-get-prev-sibling-item
                                           depth-from-buffer-node))
                           (return-from outline-tree-get-node-by-buffer-sub-tree node)))
                        (t
                         (when (setq node (outline-tree-get-node-by-buffer-sub-tree-1
                                           (treeview::treeview-get-child-item parent-node)
                                           checked-node
                                           #'treeview::treeview-get-next-sibling-item
                                           depth-from-buffer-node))
                           (return-from outline-tree-get-node-by-buffer-sub-tree node))))
                     ;; checked-node w肳ĂȂꍇAparent-node  expand/collapse Ԃ͕sB
                     ;; collapse Ԃ̏ꍇAmFȂ expand
                     (when (and (outline-tree-node-has-children-p parent-node)
                                (or (treeview::treeview-expand-p parent-node)
                                    (cond ((eq *outline-tree-expand-on-chase-cursor* :depth)
                                           (<= depth-from-buffer-node *outline-tree-expand-depth-on-chase-cursor*))
                                          (*outline-tree-expand-on-chase-cursor* t))))
                       (when (setq node (outline-tree-get-node-by-buffer-sub-tree-1
                                         (treeview::treeview-get-child-item parent-node)
                                         nil
                                         #'treeview::treeview-get-next-sibling-item
                                         depth-from-buffer-node))
                         (return-from outline-tree-get-node-by-buffer-sub-tree node))))
                   nil))
               ;; wm[hȉŌȂꍇAem[hȉŒT
               (outline-tree-get-node-by-buffer-1 (node checked-child-node direction depth-from-buffer-node)
                 (let (whole-range parent-node)
                   (setq parent-node (treeview::treeview-get-parent-item node))
                   (cond
                    ;; ͈͕s̏ꍇ (qm[hȉŒTAȂΐem[hȉŒT)
                    ((not (member (outline-tree-data-get-type node) '(:buffer-node :range-node)))
                     (or (outline-tree-get-node-by-buffer-sub-tree node checked-child-node direction
                                                                   (1+ depth-from-buffer-node))
                         (outline-tree-get-node-by-buffer-1 parent-node node nil (1- depth-from-buffer-node))))
                    ;; ͈͂Ɋ܂܂Ȃꍇ (em[hȉŒT)
                    ((and (member (outline-tree-data-get-type node) '(:range-node))
                          (not (eq (outline-tree-get-range-relation
                                    (setq whole-range (outline-tree-data-get-whole-range node))
                                    point) :inside)))
                     (cond
                      ((null whole-range)
                       (outline-tree-get-node-by-buffer-1 parent-node node nil (1- depth-from-buffer-node)))
                      ((< point (outline-tree-get-range-from whole-range))
                       (outline-tree-get-node-by-buffer-1 parent-node node :less (1- depth-from-buffer-node)))
                      (t
                       (outline-tree-get-node-by-buffer-1 parent-node node :greater (1- depth-from-buffer-node)))))
                    ;; ͈͂Ɋ܂܂ꍇ (qm[hȉŒTAȂΎm[hԂ)
                    (t
                     (or (outline-tree-get-node-by-buffer-sub-tree node checked-child-node direction
                                                                   (1+ depth-from-buffer-node))
                         node))))))
        (save-excursion
          (set-buffer buffer)
          (setq point (point))
          (if (treeview::treeview-hitem-equal buffer-node (outline-tree-get-buffer-node-by-node selected-node))
              (outline-tree-get-node-by-buffer-1 selected-node nil nil
                                                 (- (treeview::treeview-get-depth selected-node)
                                                    (treeview::treeview-get-depth buffer-node)))
            (outline-tree-get-node-by-buffer-1 buffer-node nil nil 0)))))))

(defun outline-tree-get-node-by-window (&optional window)
  "window  buffer  point ɑΉ node Ԃ"
  (outline-tree-funcall-buffer-by-window
   #'outline-tree-get-node-by-buffer window))

;;----------------------------------------------------------------------------
;; m[h̑I
;;----------------------------------------------------------------------------
(defun outline-tree-select-node (&optional arg)
  "̌^ɉAe@ node 擾AI"
  (interactive)
  (case (type-of arg)
    (integer ; node
     (outline-tree-select-node-by-node arg))
    (window
     (outline-tree-select-node-by-window arg))
    (buffer
     (outline-tree-select-node-by-buffer arg))
    (t
     (outline-tree-select-node-by-window))))
(defun outline-tree-select-node-by-node (&optional node select-only)
  "nꂽ node I"
  (interactive)
  (treeview::with-app (*outline-tree-app-id*)
    (treeview::treeview-select-act-item node select-only)))
(defun outline-tree-select-node-by-buffer (&optional buffer (select-only t))
  "buffer ɑΉ node I"
  (interactive)
  (let ((node (outline-tree-get-node-by-buffer buffer)))
    (when node
      (outline-tree-select-node-by-node node select-only))))
(defun outline-tree-select-node-by-window (&optional window (select-only t))
  "window ɑΉ node I"
  (interactive)
  (let ((node (outline-tree-get-node-by-window window)))
    (when node
      (outline-tree-select-node-by-node node select-only))))

(defun outline-tree-select-up-key-node (&optional node select-only)
  "node ƂAUp L[ۂ̈ړƂȂ node I"
  (interactive)
  (treeview::with-app (*outline-tree-app-id*)
    (treeview::treeview-select-act-up-key-item node select-only)))
(defun outline-tree-select-down-key-node (&optional node select-only)
  "node ƂADown L[ۂ̈ړƂȂ node I"
  (interactive)
  (treeview::with-app (*outline-tree-app-id*)
    (treeview::treeview-select-act-down-key-item node select-only)))
(defun outline-tree-select-left-key-node (&optional node select-only)
  "node ƂALeft L[ۂ̈ړƂȂ node I"
  (interactive)
  (treeview::with-app (*outline-tree-app-id*)
    (treeview::treeview-select-act-left-key-item node select-only)))
(defun outline-tree-select-right-key-node (&optional node select-only)
  "node ƂARight L[ۂ̈ړƂȂ node I"
  (interactive)
  (treeview::with-app (*outline-tree-app-id*)
    (treeview::treeview-select-act-right-key-item node select-only)))
(defun outline-tree-select-pageup-key-node (&optional node select-only)
  "node ƂAPageUp L[ۂ̈ړƂȂ node I"
  (interactive)
  (treeview::with-app (*outline-tree-app-id*)
    (treeview::treeview-select-act-pageup-key-item node select-only)))
(defun outline-tree-select-pagedown-key-node (&optional node select-only)
  "node ƂAPageDown L[ۂ̈ړƂȂ node I"
  (interactive)
  (treeview::with-app (*outline-tree-app-id*)
    (treeview::treeview-select-act-pagedown-key-item node select-only)))
(defun outline-tree-select-ancestor-node (&optional node select-only)
  (interactive)
  (treeview::with-app (*outline-tree-app-id*)
    (treeview::treeview-select-act-ancestor-item node select-only)))
(defun outline-tree-select-eldest-descendants-node (&optional node select-only)
  (interactive)
  (treeview::with-app (*outline-tree-app-id*)
    (treeview::treeview-select-act-eldest-descendants-item node select-only)))
(defun outline-tree-select-youngest-descendants-node (&optional node select-only)
  (interactive)
  (treeview::with-app (*outline-tree-app-id*)
    (treeview::treeview-select-act-youngest-descendants-item node select-only)))
(defun outline-tree-select-node-delay ()
  (interactive)
  (treeview::with-app (*outline-tree-app-id*)
    (treeview::treeview-select-act-item-delay)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; e@\
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;----------------------------------------------------------------------------
;; J[\Ǐ] (m[h̑I (hook))
;;----------------------------------------------------------------------------
(define-history-variable *outline-tree-chase-cursor* t)
(defun outline-tree-chase-cursor-p ()
  *outline-tree-chase-cursor*)
(defun outline-tree-toggle-chase-cursor (&optional (arg nil sv))
  (interactive "p")
  (if (null sv)
      (setq *outline-tree-chase-cursor* (not *outline-tree-chase-cursor*))
    (setq *outline-tree-chase-cursor* arg)))

(defvar *outline-tree-except-commands-for-select-node-by-window* nil)
(defvar *outline-tree-apply-commands-for-select-node-by-window*
  '(outline-tree-delete-region-by-range-node
    outline-tree-swap-region-by-next-range-node
    outline-tree-swap-region-by-prev-range-node))
(defun outline-tree-select-node-by-window-for-hook ()
  "ΏۃEBhEɊ֘Atobt@̃|CgɑΉm[hIB
AEgCŐVŁAɃnCCg̐ݒ肪ȂĂ΁A͈͂
nCCgsB
̃R}ȟł hook sA{I treeviewAoutline-tree 
Iɑ삵ĂR}h̏ꍇ͈Ŝ߁AsȂB"
  (unless *outline-tree-chase-cursor*
    (return-from outline-tree-select-node-by-window-for-hook nil))
  (treeview::with-app (*outline-tree-app-id*)
    (when (and
           ;; outline-tree JĂ
           (outline-tree-open-p)
           ;; `I̕\ȂoOH̉
           (not (get-selection-type))
           (or
            ;; R}hV{ł͂Ȃ
            (not (symbolp *this-command*))
            ;; V{ƂĂAtreeview, outline-tree2 pbP[W̃V{ł͂Ȃ
            (not (find (package-name (symbol-package *this-command*))
                       '("treeview" "outline-tree2") :test #'string=))
            ;; treeview, outline-tree2 pbP[W̃V{łAIɋĂ
            (find *this-command* *outline-tree-apply-commands-for-select-node-by-window*))
           ;; IɏOĂR}hł͂Ȃ
           (not (find *this-command*
                      *outline-tree-except-commands-for-select-node-by-window*)))
      (if (not (outline-tree-latest-outline-p-by-window))
          ;; AEgCŐVłȂꍇ
          (let ((buffer-node-by-window (outline-tree-get-buffer-node-by-window))
                (buffer-node-by-node (outline-tree-get-buffer-node-by-node
                                      (outline-tree-get-selected-node)))
                (namestring
                 (get-buffer-file-name (outline-tree-get-target-buffer)))
                (visible-buffer-p
                 (not (string-match "^ " (buffer-name (outline-tree-get-target-buffer))))))
            ;; ݂̑IĂm[h̏ʂ̃obt@m[hAEBhE
            ;; Ήobt@m[hƈقȂꍇAEBhEɑΉobt@
            ;; m[hI
            (when (and (or namestring visible-buffer-p)
                       (not (treeview::treeview-hitem-equal buffer-node-by-window buffer-node-by-node)))
              (outline-tree-select-node-by-node buffer-node-by-window t)))
        ;; AEgCŐV̏ꍇ
        (progn
          ;; EBhE point ɑΉm[hI
          (outline-tree-select-node-by-window)
          ;; m[h͈͂ɃnCCg̏ꍇ́AΉ͈͂nCCg
          (when (and (outline-tree-text-highlight-always-p)
                     (outline-tree-text-highlight-p))
            (let ((node (outline-tree-get-selected-node)))
              (when (outline-tree-range-node-p node)
                (outline-tree-set-text-highlight (outline-tree-data-get-whole-range node))))))))))

;;----------------------------------------------------------------------------
;; m[hǏ]
;;----------------------------------------------------------------------------
(define-history-variable *outline-tree-chase-node* t)
(defun outline-tree-chase-node-p ()
  *outline-tree-chase-node*)
(defun outline-tree-toggle-chase-node (&optional (arg nil sv))
  (interactive "p")
  (if (null sv)
      (setq *outline-tree-chase-node* (not *outline-tree-chase-node*))
    (setq *outline-tree-chase-node* arg)))

;;----------------------------------------------------------------------------
;; m[hΉeLXgnCCg
;;----------------------------------------------------------------------------
(define-history-variable *outline-tree-text-highlight* nil)
(defvar *outline-tree-text-highlight-tag* 'outline-tree-text-highlight)
(defun outline-tree-text-highlight-p ()
  *outline-tree-text-highlight*)
(defun outline-tree-toggle-text-highlight (&optional (arg nil sv))
  (interactive "p")
  (prog1
      (if (null sv)
          (setq *outline-tree-text-highlight* (not *outline-tree-text-highlight*))
        (setq *outline-tree-text-highlight* arg))
    (unless *outline-tree-text-highlight*
      (outline-tree-delete-text-highlight))))
(defun outline-tree-delete-text-highlight ()
  (when *outline-tree-text-highlight*
    (delete-text-attributes *outline-tree-text-highlight-tag*)))
(defun outline-tree-set-text-highlight (range)
  (outline-tree-delete-text-highlight)
  (let ((text-attributes (list-text-attributes (outline-tree-get-range-from range)
                                               (outline-tree-get-range-to range))))
    (apply #'set-text-attribute
           (append (list (outline-tree-get-range-from range)
                         (outline-tree-get-range-to range)
                         *outline-tree-text-highlight-tag*)
                   *outline-tree-text-highlight-attribute*))
    (when text-attributes
;      (sit-for 0.05)
      (dolist (text-attribute text-attributes)
        (apply #'set-text-attribute text-attribute)))))


;;----------------------------------------------------------------------------
;; m[hΉeLXgnCCg
;;----------------------------------------------------------------------------
(define-history-variable *outline-tree-text-highlight-always* nil)
(defun outline-tree-text-highlight-always-p ()
  *outline-tree-text-highlight-always*)
(defun outline-tree-toggle-text-highlight-always (&optional (arg nil sv))
  (interactive "p")
  (if (null sv)
      (setq *outline-tree-text-highlight-always* (not *outline-tree-text-highlight-always*))
    (setq *outline-tree-text-highlight-always* arg)))

;;----------------------------------------------------------------------------
;; CN^T[`
;;----------------------------------------------------------------------------
(defun outline-tree-isearch-forward (&optional reverse)
  (interactive)
  (treeview::with-app (*outline-tree-app-id*)
    (treeview::treeview-isearch-forward reverse)))
(defun outline-tree-isearch-backward ()
  (interactive)
  (outline-tree-isearch-forward t))

;;----------------------------------------------------------------------------
;; AEgCc[\ł̃obt@Xg
;;----------------------------------------------------------------------------
(defun outline-tree-buffer-list (&optional top-node)
  (treeview::with-app (*outline-tree-app-id*)
    (unless top-node
      (setq top-node winapi:TVI_ROOT))
    (let ((stop-node (if (and top-node (plusp top-node))
                       (treeview::treeview-get-next-sibling-item top-node)
                     nil))
          (node (treeview::treeview-get-down-item top-node))
          buffer-list)
      (while (and (outline-tree-node-valid-p node)
                  (or (not (outline-tree-node-valid-p stop-node))
                      (treeview::treeview-hitem-lessp node stop-node)))
        (when (outline-tree-buffer-node-p node)
          (push (outline-tree-data-get-buffer node) buffer-list))
        (setq node (treeview::treeview-get-down-item node)))
      (nreverse buffer-list))))

(defun outline-tree-get-next-buffer (&optional buffer reverse)
  (unless buffer
    (setq buffer (selected-buffer)))
  (let ((buffer-list (outline-tree-buffer-list)))
    (if reverse
        (setq buffer-list (reverse buffer-list)))
    (setq buffer-list
          (safe-cdr (member buffer (append buffer-list buffer-list))))
    (dolist (buffer buffer-list)
      (unless (string-match "^ " (buffer-name buffer))
        (return-from outline-tree-get-next-buffer buffer))))
  nil)

(defun outline-tree-next-buffer ()
  (interactive)
  (let* ((cur (selected-buffer))
         (next (outline-tree-get-next-buffer cur nil)))
    (if (and (bufferp next) (not (eq cur next)))
        (set-buffer next)
      nil)))

(defun outline-tree-previous-buffer ()
  (interactive)
  (let* ((cur (selected-buffer))
         (prev (outline-tree-get-next-buffer cur t)))
    (if (and (bufferp prev) (not (eq cur prev)))
        (set-buffer prev)
      nil)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; vpeB[V[g
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defvar *outline-tree-option-prop-page* nil)
(defvar *outline-tree-option-prop-page-no* nil)

(defun outline-tree-add-option-prop-page (ident tmpl init handlers result)
  (setq *outline-tree-option-prop-page* (delete ident *outline-tree-option-prop-page* :test #'eq
                                           :key #'(lambda (x) (if (consp x) (car x) nil))))
  (setf (get ident 'outline-tree-prop-result) result)
  (push (list ident tmpl init handlers) *outline-tree-option-prop-page*))

(defun outline-tree-option-property-sheet ()
  (interactive)
  (let (sheet result)
    (dolist (page *outline-tree-option-prop-page*)
      (cond ((symbolp page)
             (push page sheet))
            (t
             (push (list (car page)
                         (cadr page)
                         (let ((init (caddr page)))
                           (when init
                             (funcall init)))
                         (cadddr page))
                   sheet))))
    (multiple-value-setq (result *outline-tree-option-prop-page-no*)
      (property-sheet sheet
                      (format nil "outline-tree (~A) ݒ" *outline-tree-version*)
                      *outline-tree-option-prop-page-no*))
    (dolist (r result)
      (let ((f (get (car r) 'outline-tree-prop-result)))
        (when f
          (funcall f (cdr r)))))))

;;----------------------------------------------------------------------------
;; {vpeB[V[g
;;----------------------------------------------------------------------------
(outline-tree-add-option-prop-page
 'basic
 (let (dialog-base-side dialog-size
       dialog-base-height dialog-height
       controls)
   ;;
   (setq dialog-base-side 4)
   (setq dialog-base-height 4)
   (setq dialog-height dialog-base-height)
   (push `(:button nil "ݒ"                              #x50020007
           ,dialog-base-side ,dialog-height 112 74) controls)
   (incf dialog-height 10)
   (push `(:button chase-cursor "J[\Ǐ](&C)"             #x50010003
           ,(+ dialog-base-side 4) ,dialog-height 100 12) controls)
   (incf dialog-height 12)
   (push `(:button chase-node "m[hǏ](&N)"                 #x50010003
           ,(+ dialog-base-side 4) ,dialog-height 100 12) controls)
   (incf dialog-height 12)
   (push `(:button text-highlight "m[h͈̓nCCg(&H)"   #x50010003
           ,(+ dialog-base-side 4) ,dialog-height 100 12) controls)
   (incf dialog-height 12)
   (push `(:button text-highlight-always "m[h͈͂ɃnCCg(&A)" #x50010003
           ,(+ dialog-base-side 4) ,dialog-height 100 12) controls)
   (incf dialog-height 12)
   (push `(:button swap-discontinuous-range-node "sAm[hւ(&D)" #x50010003
           ,(+ dialog-base-side 4) ,dialog-height 100 12) controls)
   ;;
   (setq dialog-base-side 120)
   (setq dialog-base-height 4)
   (setq dialog-height dialog-base-height)
;   (push `(:button nil "AEgCc[N"                #x50020007
;           ,dialog-base-side ,dialog-height 112 74) controls)
   (push `(:button nil "AEgCc[N"                #x50020007
           ,dialog-base-side ,dialog-height 112 40) controls)
   (incf dialog-height 10)
   (push `(:button one-shot-create "xyzzy N̓AEgC\nc[NȂ(&O)" #x50012003
           ,(+ dialog-base-side 4) ,dialog-height 100 24) controls)
   ;;
   (setq dialog-base-side 120)
   (setq dialog-height (+ dialog-base-height 44))
   (push `(:button nil "m[h\"                            #x50020007
           ,dialog-base-side ,dialog-height 112 30) controls)
   (incf dialog-height 10)
   (push `(:static nil "tH_\(&W):"                 #x50020000
           ,(+ dialog-base-side 4) ,(+ dialog-height 3) 64 8) controls)
   (push `(:edit folder-name-length-num nil                    #x50812086
           ,(+ dialog-base-side 72) ,dialog-height 30 12) controls)
   (push `(:spin folder-name-length-spin nil                   #x500000b6
           ,(+ dialog-base-side 72) ,dialog-height 9 12) controls)

   ;;
   (setq dialog-base-side 4)
   (incf dialog-base-height 78)
   (setq dialog-height dialog-base-height)
   (push `(:button nil "GfB^\s"                        #x50020007
           ,dialog-base-side ,dialog-height 72 64) controls)
   (incf dialog-height 10)
   (push `(:button recenter-nil  "䂵Ȃ(&1)"              #x50000009
           ,(+ dialog-base-side 4) ,dialog-height 50 12) controls)
   (incf dialog-height 12)
   (push `(:button recenter-t    "Z^[(&2)"                #x50000009
           ,(+ dialog-base-side 4) ,dialog-height 50 12) controls)
   (incf dialog-height 12)
   (push `(:button recenter-line "}[Wsw(&3)"          #x50000009
           ,(+ dialog-base-side 4) ,dialog-height 64 12) controls)
   (incf dialog-height 12)
   (push `(:edit recenter-line-num nil                         #x50812086
           ,(+ dialog-base-side 24) ,dialog-height 40 12) controls)
   (push `(:spin recenter-spin nil                             #x500000b6
           ,(+ dialog-base-side 24) ,dialog-height 9 12) controls)
   ;;
   (setq dialog-base-side 80)
   (setq dialog-height dialog-base-height)
   (push `(:button nil "쐬WJKw"                        #x50020007
           ,dialog-base-side ,dialog-height 72 64) controls)
   (incf dialog-height 10)
   (push `(:button expand-on-create-nil "WJȂ(&4)"       #x50000009
           ,(+ dialog-base-side 4) ,dialog-height 50 12) controls)
   (incf dialog-height 12)
   (push `(:button expand-on-create-t   "SWJ(&5)"           #x50000009
           ,(+ dialog-base-side 4) ,dialog-height 50 12) controls)
   (incf dialog-height 12)
   (push `(:button expand-on-create-depth "Kww(&6)"       #x50000009
           ,(+ dialog-base-side 4) ,dialog-height 58 12) controls)
   (incf dialog-height 12)
   (push `(:edit expand-on-create-depth-num nil                #x50812086
           ,(+ dialog-base-side 24) ,dialog-height 40 12) controls)
   (push `(:spin expand-on-create-depth-spin nil               #x500000b6
           ,(+ dialog-base-side 24) ,dialog-height 9 12) controls)
   ;;
   (setq dialog-base-side 156)
   (setq dialog-height dialog-base-height)
   (push `(:button nil "Ǐ]WJKw"                        #x50020007
           ,dialog-base-side ,dialog-height 72 64) controls)
   (incf dialog-height 10)
   (push `(:button expand-on-chase-nil "WJȂ(&7)"        #x50000009
           ,(+ dialog-base-side 4) ,dialog-height 50 12) controls)
   (incf dialog-height 12)
   (push `(:button expand-on-chase-t   "SWJ(&8)"            #x50000009
           ,(+ dialog-base-side 4) ,dialog-height 50 12) controls)
   (incf dialog-height 12)
   (push `(:button expand-on-chase-depth "Kww(&9)"        #x50000009
           ,(+ dialog-base-side 4) ,dialog-height 58 12) controls)
   (incf dialog-height 12)
   (push `(:edit expand-on-chase-depth-num nil                 #x50812086
           ,(+ dialog-base-side 24) ,dialog-height 40 12) controls)
   (push `(:spin expand-on-chase-depth-spin nil                #x500000b6
           ,(+ dialog-base-side 24) ,dialog-height 9 12) controls)
   ;;
   (setq dialog-base-side 4)
   (incf dialog-base-height 68)
   (setq dialog-height dialog-base-height)
   (push `(:button nil "AEgCΏۃEBhE(&U)"        #x50020007
           ,dialog-base-side ,dialog-height 180 28) controls)
   (incf dialog-height 10)
   (push `(:combobox target-window nil                         #x50210843
           ,(+ dialog-base-side 4) ,dialog-height 170 96) controls)
   ;;
   (setq dialog-base-side 4)
   (incf dialog-base-height 32)
   (setq dialog-height dialog-base-height)
   (push `(:button nil "j["                              #x50020007
           ,dialog-base-side ,dialog-height 230 28) controls)
   (incf dialog-height 10)
   (push `(:button menu "j[ǉ(&M)"                   #x50010003
           ,(+ dialog-base-side 4) ,dialog-height 80 14) controls)
   (push `(:static nil "j[(&T):"                   #x50020000
           ,(+ dialog-base-side 90) ,(+ dialog-height 3) 56 8) controls)
   (push `(:edit menu-name nil                                 #x50810480
           ,(+ dialog-base-side 146) ,dialog-height 74 14) controls)

   (setq controls (nreverse controls))
   `(dialog 0 0 260 220
     (:caption "{ݒ")
     (:control
      ,@controls)))
 #'(lambda ()
     (let (controls-initializers)
       (push `(chase-cursor . ,*outline-tree-chase-cursor*) controls-initializers)
       (push `(chase-node . ,*outline-tree-chase-node*) controls-initializers)
       (push `(text-highlight . ,*outline-tree-text-highlight*) controls-initializers)
       (push `(text-highlight-always . ,*outline-tree-text-highlight-always*) controls-initializers)
       (push `(swap-discontinuous-range-node . ,*outline-tree-available-swap-discontinuous-range-node*)
             controls-initializers)
       ;;
       (when (eq *outline-tree-use* :one-shot)
         (push '(one-shot-create . t) controls-initializers))
       ;;
       (cond
        ((and (integerp *outline-tree-abbreviate-display-folder-name-length*)
              (plusp *outline-tree-abbreviate-display-folder-name-length*))
         (push `(folder-name-length-num
                 . ,(format nil "~D" *outline-tree-abbreviate-display-folder-name-length*))
               controls-initializers))
        (t
         (push `(folder-name-length-num . "0") controls-initializers)))
       ;;
       (push (case *outline-tree-editor-recenter*
               ((nil) '(recenter-nil . t))
               (:line '(recenter-line . t))
               (t     '(recenter-t . t)))
             controls-initializers)
       (let ((recenter *outline-tree-editor-recenter-line*))
         (unless (and (integerp recenter) (<= 0 recenter))
           (setq recenter 0))
         (push `(recenter-line-num . ,(format nil "~D" recenter)) controls-initializers))
       ;;
       (push (case *outline-tree-expand-on-create-outline*
               ((nil)  '(expand-on-create-nil . t))
               (:depth '(expand-on-create-depth . t))
               (t      '(expand-on-create-t . t)))
             controls-initializers)
       (let ((depth *outline-tree-expand-depth-on-create-outline*))
         (unless (and (integerp depth) (<= 0 depth))
           (setq depth 0))
         (push `(expand-on-create-depth-num . ,(format nil "~D" depth)) controls-initializers))
       ;;
       (push (case *outline-tree-expand-on-chase-cursor*
               ((nil)  '(expand-on-chase-nil . t))
               (:depth '(expand-on-chase-depth . t))
               (t      '(expand-on-chase-t . t)))
             controls-initializers)
       (let ((depth *outline-tree-expand-depth-on-chase-cursor*))
         (unless (and (integerp depth) (<= 0 depth))
           (setq depth 0))
         (push `(expand-on-chase-depth-num . ,(format nil "~D" depth)) controls-initializers))
       ;;
       (let ((window-list (mapcar 'car (caddr (current-window-configuration))))
             window-name-list window-position)
         (setq window-name-list
               (mapcar #'(lambda (window)
                           (format nil "~A~S:: <~A>"
                                   (if (eq window (selected-window)) " " "@  ")
                                   window (buffer-name (window-buffer window))))
                       window-list))
         (push "@  ANeBuEBhE" window-name-list)
         (push `(target-window . ,window-name-list) controls-initializers)
         (if (setq window-position (position *outline-tree-target-window* window-list))
             (incf window-position)
           (setq window-position 0))
         (push `(target-window . ,window-position) controls-initializers))
       ;;
       (push `(menu . ,*outline-tree-set-app-menu*) controls-initializers)
       (push `(menu-name . ,(if (and (stringp *outline-tree-app-menu-name*)
                                     (string/= *outline-tree-app-menu-name* ""))
                                *outline-tree-app-menu-name* "&Outline-Tree"))
             controls-initializers)
       (nreverse controls-initializers)))
 '((folder-name-length-num :type integer :min 0 :max 10000 :range-error "0ȏw肵Ă")
   (folder-name-length-spin :type integer :min 0 :max 10000)
   (recenter-line-num :type integer :min 0 :max 10000 :range-error "0ȏw肵Ă")
   (recenter-spin :type integer :min 0 :max 10000)
   (expand-on-create-depth-num :type integer :min 0 :max 10000 :range-error "0ȏw肵Ă")
   (expand-on-create-depth-spin :type integer :min 0 :max 10000)
   (expand-on-chase-depth-num :type integer :min 0 :max 10000 :range-error "0ȏw肵Ă")
   (expand-on-chase-depth-spin :type integer :min 0 :max 10000)
   (target-window :index t))
 #'(lambda (data)
     ;;
     (setq *outline-tree-chase-cursor* (cdr (assoc 'chase-cursor data)))
     (setq *outline-tree-chase-node* (cdr (assoc 'chase-node data)))
     (setq *outline-tree-text-highlight* (cdr (assoc 'text-highlight data)))
     (setq *outline-tree-text-highlight-always* (cdr (assoc 'text-highlight-always data)))
     (setq *outline-tree-available-swap-discontinuous-range-node*
           (cdr (assoc 'swap-discontinuous-range-node data)))
     ;;
     (cond
      ((cdr (assoc 'one-shot-create data))
       (setq *outline-tree-use* :one-shot))
      (t
       (setq *outline-tree-use* (outline-tree-exist-p))))
     ;;
     (setq *outline-tree-abbreviate-display-folder-name-length*
           (cdr (assoc 'folder-name-length-num data)))
     (outline-tree-abbreviate-display-folder-name
      *outline-tree-abbreviate-display-folder-name-length*)

     ;;
     (cond
      ((cdr (assoc 'recenter-nil data))
       (setq *outline-tree-editor-recenter* nil))
      ((cdr (assoc 'recenter-line data))
       (setq *outline-tree-editor-recenter* :line))
      ((cdr (assoc 'recenter-t data))
       (setq *outline-tree-editor-recenter* t)))
     (setq *outline-tree-editor-recenter-line*
           (cdr (assoc 'recenter-line-num data)))
     ;;
     (cond
      ((cdr (assoc 'expand-on-create-nil data))
       (setq *outline-tree-expand-on-create-outline* nil))
      ((cdr (assoc 'expand-on-create-depth data))
       (setq *outline-tree-expand-on-create-outline* :depth))
      ((cdr (assoc 'expand-on-create-t data))
       (setq *outline-tree-expand-on-create-outline* t)))
     (setq *outline-tree-expand-depth-on-create-outline*
           (cdr (assoc 'expand-on-create-depth-num data)))
     ;;
     (cond
      ((cdr (assoc 'expand-on-chase-nil data))
       (setq *outline-tree-expand-on-chase-cursor* nil))
      ((cdr (assoc 'expand-on-chase-depth data))
       (setq *outline-tree-expand-on-chase-cursor* :depth))
      ((cdr (assoc 'expand-on-chase-t data))
       (setq *outline-tree-expand-on-chase-cursor* t)))
     (setq *outline-tree-expand-depth-on-chase-cursor*
           (cdr (assoc 'expand-on-chase-depth-num data)))
     ;;
     (let ((window-list-index (cdr (assoc 'target-window data)))
           (window-list (mapcar 'car (caddr (current-window-configuration)))))
       (if (plusp window-list-index)
           (setq *outline-tree-target-window* (nth (1- window-list-index) window-list))
         (setq *outline-tree-target-window* nil)))
     ;;
     (unless (and (equal *outline-tree-set-app-menu* (cdr (assoc 'menu data)))
                  (equal *outline-tree-app-menu-name* (cdr (assoc 'menu-name data))))
       (setq *outline-tree-set-app-menu* (cdr (assoc 'menu data)))
       (setq *outline-tree-app-menu-name* (cdr (assoc 'menu-name data)))
       (if *outline-tree-set-app-menu*
           (outline-tree-insert-app-menu)
         (outline-tree-delete-app-menu)))
     ))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; buffer-node Ή@\
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun outline-tree-set-buffer-by-node (&optional node)
  (treeview::with-app (*outline-tree-app-id*)
    (unless node
      (setq node (outline-tree-get-selected-node)))
    (setq node (outline-tree-get-buffer-node-by-node node))
    (let ((window-list (mapcar 'car (caddr (current-window-configuration))))
          (buffer (outline-tree-get-buffer-by-node node))
          (current-window (selected-window)))
      (when (and (windowp *outline-tree-target-window*)
                 (not (eq *outline-tree-target-window* (selected-window)))
                 (not (minibuffer-window-p *outline-tree-target-window*))
                 (member *outline-tree-target-window* window-list))
        (set-window *outline-tree-target-window*))
      (set-buffer buffer)
      (set-window current-window))
    (winapi:InvalidateRect (get-window-handle) 0 1)
    (winapi:UpdateWindow (get-window-handle))
    (refresh-title-bar)
    (refresh-screen 1)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; range-node ҏW@\
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;----------------------------------------------------------------------------
;; range-node 폜
;;----------------------------------------------------------------------------
(defun outline-tree-valid-delete-range-node-region-p (range-node)
  (save-excursion
    (set-buffer (outline-tree-get-buffer-by-node range-node))
    (and (<= (point-min)
             (outline-tree-get-range-from (outline-tree-data-get-whole-range range-node)))
         (<= (outline-tree-get-range-to (outline-tree-data-get-whole-range range-node))
             (point-max)))))

(defun outline-tree-delete-region-by-range-node (&optional range-node)
  "range-node ƂƂɁA[W폜"
  (interactive)
  (treeview::with-app (*outline-tree-app-id*)
    (unless range-node
      (setq range-node (outline-tree-get-selected-node)))
    (unless (outline-tree-range-node-p range-node)
      (message "~A" "͈̓m[hł͂܂")
      (return-from outline-tree-delete-region-by-range-node))
    (unless (outline-tree-latest-outline-p-by-node range-node)
      (message "~A" "AEgCŐVł܂")
      (return-from outline-tree-delete-region-by-range-node))
    (let* ((buffer (outline-tree-get-buffer-by-node range-node))
           (whole-range (outline-tree-data-get-whole-range range-node))
           (from (outline-tree-get-range-from whole-range))
           (to (outline-tree-get-range-to whole-range)))
      (when (outline-tree-buffer-read-only-p buffer)
        (message "~A" "݋֎~obt@ł")
        (return-from outline-tree-delete-region-by-range-node))
      (unless (outline-tree-valid-region-by-range-node-p range-node)
        (message "~A" "Ώ۔͈͂i[COĂ܂")
        (return-from outline-tree-delete-region-by-range-node))
      (save-excursion
        (set-buffer buffer)
        ;; m[h폜 / f[^C
        (outline-tree-delete-region-update-node-data-tree
         (outline-tree-get-buffer-node-by-node range-node)
         (cons from to))
        ;; ۂ delete
        (delete-region from to)
        ;; undo boundary ݒ
        (undo-boundary)
        ;; ŐṼAEgCƔF悤ݒ
        (setq outline-tree-outline-modified (buffer-modified-count)))
      ;; ړ
      (outline-tree-select-node-by-node (outline-tree-get-selected-node) nil)
      (refresh-screen))))
(defun outline-tree-delete-region-update-node-data (node delete-range)
  (let ((buffer (outline-tree-get-buffer-by-node node))
        (delete-length (- (outline-tree-get-range-to delete-range)
                          (outline-tree-get-range-from delete-range)))
        range point)
    (case (outline-tree-data-get-type node)
      (:range-node
       (setq range (outline-tree-data-get-whole-range node))
       (case (outline-tree-get-range-relation delete-range range)
         (:before
          nil)
         (:after
          (outline-tree-set-offset-node-data-tree node (- delete-length))
          nil)
         ((:equal :inside)
          (outline-tree-remove-node-tree node)
          nil)
         (:outside
          (unless (outline-tree-range-to-unlimited-p range)
            (outline-tree-update-range-node
             node :whole-range (cons (outline-tree-get-range-from range)
                                     (- (outline-tree-get-range-to range) delete-length))))
          t)
         (:part-share
          (outline-tree-remove-node-tree node)
          nil)
         (t
          t)))
      (:point-node
       (setq point (outline-tree-data-get-point node))
       (case (outline-tree-get-range-relation delete-range point)
         (:before
          nil)
         (:after
          (outline-tree-set-offset-node-data-tree node (- delete-length))
          nil)
         (:inside
          (outline-tree-remove-node-tree node)
          nil)
         (t
          t)))
      (t
       t)
      )))

(defun outline-tree-delete-region-update-node-data-tree (node delete-range)
  (treeview::treeview-funcall-recursive-tree-top-down
   node #'(lambda (node) (outline-tree-delete-region-update-node-data node delete-range))))

;;----------------------------------------------------------------------------
;; range-node ւ
;;----------------------------------------------------------------------------
(define-history-variable *outline-tree-available-swap-discontinuous-range-node* nil
  "sA range-node łĂւ")
(defun outline-tree-available-swap-discontinuous-range-node-p ()
  "sA range-node łĂւ"
  *outline-tree-available-swap-discontinuous-range-node*)
(defun outline-tree-toggle-available-swap-discontinuous-range-node (&optional (arg nil sv))
  "sA range-node łĂւ̐ݒgO"
  (interactive "p")
  (if (null sv)
      (setq *outline-tree-available-swap-discontinuous-range-node*
            (not *outline-tree-available-swap-discontinuous-range-node*))
    (setq *outline-tree-available-swap-discontinuous-range-node* arg)))
(defun outline-tree-valid-region-by-range-node-p (range-node)
  "range-node ̃[WAҏW\ȗ̈悩 (narrowing ĂȂ)"
  (save-excursion
    (set-buffer (outline-tree-get-buffer-by-node range-node))
    (let ((whole-range (outline-tree-data-get-whole-range range-node)))
      (and (<= (point-min) (outline-tree-get-range-from whole-range))
           (<= (outline-tree-get-range-to whole-range) (point-max))))))
(defun outline-tree-get-swap-target-range-node (range-node &optional prev)
  "ւ\ range-node Ԃ"
  (treeview::with-app (*outline-tree-app-id*)
    (unless (and (outline-tree-node-valid-p range-node)
                 (outline-tree-range-node-p range-node))
      (return-from outline-tree-get-swap-target-range-node
        (values nil "w肳ꂽm[h͈̓m[hł͂܂")))
    (let (lower-node upper-node target-node)
      (if prev
          (progn
            (setq lower-node range-node)
            (setq upper-node (treeview::treeview-get-prev-sibling-item range-node))
            (setq target-node upper-node)
            (unless (outline-tree-node-valid-p upper-node)
              (return-from outline-tree-get-swap-target-range-node
                (values nil "ւ\ȃm[h݂܂"))))
        (progn
          (setq upper-node range-node)
          (setq lower-node (treeview::treeview-get-next-sibling-item range-node))
          (setq target-node lower-node)
          (unless (outline-tree-node-valid-p lower-node)
            (return-from outline-tree-get-swap-target-range-node
              (values nil "ւ\ȃm[h݂܂")))))
      (unless (and (outline-tree-range-node-p upper-node)
                   (outline-tree-range-node-p lower-node))
        (return-from outline-tree-get-swap-target-range-node
          (values nil "ւΏۃm[h͈̓m[hł͂܂")))
      (unless (and (not (outline-tree-header-node-p upper-node))
                   (not (outline-tree-header-node-p lower-node)))
        (return-from outline-tree-get-swap-target-range-node
          (values nil "wb_m[h͓ւł܂")))
      (unless (eq (outline-tree-data-get-sub-type upper-node)
                  (outline-tree-data-get-sub-type lower-node))
        (return-from outline-tree-get-swap-target-range-node
          (values nil "قȂނ̃m[h͓ւł܂")))
      (unless (or (outline-tree-available-swap-discontinuous-range-node-p)
                  (eql (outline-tree-get-range-to (outline-tree-data-get-whole-range upper-node))
                       (outline-tree-get-range-from (outline-tree-data-get-whole-range lower-node))))
        (return-from outline-tree-get-swap-target-range-node
          (values nil "m[h͈̔͂AĂ܂")))
      target-node)))
(defun outline-tree-swap-region-by-next-range-node (&optional range-node prev)
  "range-node  range-node ƓւA[W̓eւ"
  (interactive)
  (treeview::with-app (*outline-tree-app-id*)
    (unless range-node
      (setq range-node (outline-tree-get-selected-node)))
    (unless (outline-tree-latest-outline-p-by-node range-node)
      (message "~A" "AEgCŐVł܂")
      (return-from outline-tree-swap-region-by-next-range-node))
    (let (target-node error-reason upper-node lower-node buffer)
      (multiple-value-setq (target-node error-reason)
        (outline-tree-get-swap-target-range-node range-node prev))
      (unless target-node
        (if error-reason
            (message "~A" error-reason)
          (message "~A" "ւ\ȃm[h݂܂"))
        (return-from outline-tree-swap-region-by-next-range-node))
      (if prev
          (setq upper-node target-node
                lower-node range-node)
        (setq upper-node range-node
              lower-node target-node))
      (setq buffer (outline-tree-get-buffer-by-node range-node))
      (save-excursion
        (set-buffer buffer)
        (when (outline-tree-buffer-read-only-p)
          (message "~A" "݋֎~obt@ł")
          (return-from outline-tree-swap-region-by-next-range-node))
        (unless (and (outline-tree-valid-region-by-range-node-p upper-node)
                     (outline-tree-valid-region-by-range-node-p lower-node))
          (message "~A" "Ώ۔͈͂i[COĂ܂")
          (return-from outline-tree-swap-region-by-next-range-node))
        ;; ͈͂obt@܂(to  nil)̏ꍇ
        ;;   E:blank-line-oriented ̏ꍇA "\n\n" K悤
        ;;   ELȊȌꍇA "\n" K悤
        (when (outline-tree-range-to-unlimited-p
               (outline-tree-data-get-whole-range lower-node))
          (goto-char (point-max))
          (cond
           ((member :blank-line-oriented
                    (nth 2 (find (outline-tree-get-create-outline-function-by-buffer)
                                 *outline-tree-create-outline-function-alist* :key #'car)))
            (unless (and (char= (char-before (point)) #\LFD)
                         (char= (char-before (1- (point))) #\LFD))
              (if (char= (char-before (point)) #\LFD)
                  (insert "\n")
                (insert "\n\n"))))
           (t
            (unless (char= (char-before (point)) #\LFD)
              (insert "\n")))))
        ;; ۂ̃Xbv
        (let* ((lower-whole-range (outline-tree-data-get-whole-range lower-node))
               (upper-whole-range (outline-tree-data-get-whole-range upper-node))
               (lower-from (outline-tree-get-range-from lower-whole-range))
               (lower-to (outline-tree-get-range-to lower-whole-range))
               (upper-from (outline-tree-get-range-from upper-whole-range))
               (upper-to (outline-tree-get-range-to upper-whole-range))
               (lower-length (- lower-to lower-from))
               (upper-length (- upper-to upper-from))
               (lower-offset (- upper-from lower-from))
               (upper-offset (+ (- lower-offset) lower-length (- upper-length)))
               (lower-string (buffer-substring lower-from lower-to))
               (upper-string (buffer-substring upper-from upper-to)))
          ;; m[hf[^C
          (outline-tree-swap-region-update-node-data-tree
           (outline-tree-get-buffer-node-by-node lower-node)
           upper-whole-range lower-whole-range)
          ;; ҏẄ̈ړ
          (delete-region lower-from lower-to)
          (delete-region upper-from upper-to)
          (goto-char upper-from)
          (insert lower-string)
          (goto-char (+ lower-from lower-length (- upper-length)))
          (insert upper-string)
          ;; undo boundary ݒ
          (undo-boundary))
        ;; m[h\Xbv
        (let ((parent-node (treeview::treeview-get-parent-item range-node))
              node (i 0))
          (when (outline-tree-node-has-children-p parent-node)
            (setq node (treeview::treeview-get-child-item parent-node))
            (while (outline-tree-node-valid-p node)
              (treeview::treeview-set-item-data node (incf i))
              (setq node (treeview::treeview-get-next-sibling-item node))))
          (setq i (treeview::treeview-get-item-data upper-node))
          (treeview::treeview-set-item-data upper-node (treeview::treeview-get-item-data lower-node))
          (treeview::treeview-set-item-data lower-node i)
          (treeview::treeview-sort-children-cb-lparam-ascending parent-node))
        ;; ŐṼAEgCƔF悤ݒ
        (setq outline-tree-outline-modified (buffer-modified-count)))
      ;; ړ
      (outline-tree-select-node-by-node range-node nil)
      (refresh-screen))))
(defun outline-tree-swap-region-by-prev-range-node (&optional range-node)
  "range-node O range-node ƓւA[W̓eւ"
  (interactive)
  (outline-tree-swap-region-by-next-range-node range-node t))

(defun outline-tree-set-offset-node-data (node offset)
  (let ((buffer (outline-tree-get-buffer-by-node node))
        range from to point)
    (case (outline-tree-data-get-type node)
      (:range-node
       (when (setq range (outline-tree-data-get-whole-range node))
         (outline-tree-update-range-node
          node
          :whole-range (cons (+ (outline-tree-get-range-from range) offset)
                             (+ (outline-tree-get-range-to range buffer) offset))))
       (when (setq range (outline-tree-data-get-title-range node))
         (outline-tree-update-range-node
          node
          :title-range (cons (+ (outline-tree-get-range-from range) offset)
                             (+ (outline-tree-get-range-to range buffer) offset)))))
      (:point-node
       (when (setq point (outline-tree-data-get-point node))
         (outline-tree-update-point-node node (+ point offset))))
      ((:buffer-node :folder-node :category-node :info-node :section-node)
       nil))))
(defun outline-tree-set-offset-node-data-tree (node offset)
  (treeview::treeview-funcall-recursive-tree-top-down
   node #'(lambda (node) (outline-tree-set-offset-node-data node offset) t)))

(defun outline-tree-swap-region-update-node-data (node upper-range lower-range)
  (let ((buffer (outline-tree-get-buffer-by-node node))
        (upper-length (- (outline-tree-get-range-to upper-range)
                         (outline-tree-get-range-from upper-range)))
        (lower-length (- (outline-tree-get-range-to lower-range)
                         (outline-tree-get-range-from lower-range)))
        (interval-length (- (outline-tree-get-range-from lower-range)
                            (outline-tree-get-range-to upper-range)))
        range point upper-relation lower-relation)
    (case (outline-tree-data-get-type node)
      (:range-node
       (setq range (outline-tree-data-get-whole-range node))
       (setq upper-relation (outline-tree-get-range-relation upper-range range))
       (setq lower-relation (outline-tree-get-range-relation lower-range range))
       (cond
        ((or (eq upper-relation :part-share) (eq lower-relation :part-share))
         (outline-tree-remove-node-tree node)
         nil)
        ((eq upper-relation :before)
         nil)
        ((or (eq upper-relation :inside) (eq upper-relation :equal))
         (outline-tree-set-offset-node-data-tree node (+ lower-length interval-length))
         nil)
        ((and (eq upper-relation :after) (eq lower-relation :before))
         (outline-tree-set-offset-node-data-tree node (+ lower-length (- upper-length)))
         nil)
        ((or (eq lower-relation :inside) (eq lower-relation :equal))
         (outline-tree-set-offset-node-data-tree node (+ (- upper-length) (- interval-length)))
         nil)
        ((eq lower-relation :after)
         nil)
        ((and (eq upper-relation :outside) (eq lower-relation :outside))
         t)
        ((eq upper-relation :outside)
         (unless (outline-tree-range-to-unlimited-p range)
           (outline-tree-update-range-node
            node :whole-range (cons (outline-tree-get-range-from range)
                                    (+ (outline-tree-get-range-to range)
                                       (- upper-length) lower-length))))
         t)
        ((eq lower-relation :outside)
         (outline-tree-update-range-node
          node :whole-range (cons (+ (outline-tree-get-range-from range)
                                     (- upper-length) lower-length)
                                  (if (outline-tree-range-to-unlimited-p range)
                                      nil (outline-tree-get-range-to range))))
         t)))
      (:point-node
       (setq point (outline-tree-data-get-point node))
       (setq upper-relation (outline-tree-get-range-relation upper-range point))
       (setq lower-relation (outline-tree-get-range-relation lower-range point))
       (cond
        ((eq upper-relation :before))
        ((eq upper-relation :inside)
         (outline-tree-set-offset-node-data-tree node (+ lower-length interval-length)))
        ((and (eq upper-relation :after) (eq lower-relation :before))
         (outline-tree-set-offset-node-data-tree node (+ lower-length (- upper-length))))
        ((eq lower-relation :inside)
         (outline-tree-set-offset-node-data-tree node (+ (- upper-length) (- interval-length))))
        ((eq lower-relation :after)))
       nil)
      (t
       t))))

(defun outline-tree-swap-region-update-node-data-tree (node upper-range lower-range)
  (treeview::treeview-funcall-recursive-tree-top-down
   node #'(lambda (node) (outline-tree-swap-region-update-node-data node upper-range lower-range))))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ֐
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;----------------------------------------------------------------------------
;; ͈
;;----------------------------------------------------------------------------
(defun outline-tree-get-range-from (range &optional buffer)
  (or (car range) (buffer-size buffer)))
(defun outline-tree-get-range-to (range &optional buffer)
  (or (cdr range) (buffer-size buffer)))
(defun outline-tree-range-to-unlimited-p (range)
  (null (cdr range)))

;;----------------------------------------------------------------------------
;; ͈͂Ƃ̊֌W𔻒
;;----------------------------------------------------------------------------
(defun outline-tree-get-range-relation (base-range range-or-point &optional buffer)
  (let ((base-from (outline-tree-get-range-from base-range buffer))
        (base-to (outline-tree-get-range-to base-range buffer))
        (base-to-unlimited-p (not (cdr base-range)))
        range point target-from target-to)
    (if (consp range-or-point)
        (progn
          (setq range range-or-point)
          (setq target-from (outline-tree-get-range-from range buffer))
          (setq target-to (outline-tree-get-range-to range buffer)))
      (setq point range-or-point))
    (cond
     ;; range ̏ꍇ
     (range
      (cond
       ;; Ȍꍇ
       ((<= target-to base-from)
        :before)
       ;; ̏ꍇ
       ((<= base-to target-from)
        :after)
       ;; vꍇ
       ((and (= base-from target-from) (= base-to target-to))
        :equal)
       ;; base-range ɓꍇ
       ((and (<= base-from target-from) (<= target-to base-to))
        :inside)
       ;; base-range ꍇ
       ((and (<= target-from base-from) (<= base-to target-to))
        :outside)
       (t
        :part-share)))
     ;; point ̏ꍇ
     (t
      (cond
       ((< point base-from)
        :before)
       (base-to-unlimited-p
        :inside)
       ((<= base-to point)
        :after)
       (t
        :inside))))))

;;----------------------------------------------------------------------------
;; ͈͂߁AV͈͂Ԃ (2004/11/29)
;;----------------------------------------------------------------------------
(defun outline-tree-range-narrow (range from to)
  "range ̒l from  to ŋ߁AV range Ԃ"
  (let ((return-range '(nil . nil)))
    (if (and from (or (not (car range)) (< (car range) from)))
        (rplaca return-range from)
      (rplaca return-range (car range)))
    (if (and to (or (not (cdr range)) (< to (cdr range))))
        (rplacd return-range to)
      (rplacd return-range (cdr range)))
    return-range))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; outline 쐬֐
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;----------------------------------------------------------------------------
;; outline 쐬֐o^@\
;;----------------------------------------------------------------------------
(defvar *outline-tree-create-outline-function-alist* nil)
(defun outline-tree-add-create-outline-function (func-symbol func-name func-type &optional func-doc)
  (delete func-symbol *outline-tree-create-outline-function-alist* :key #'car)
  (setq *outline-tree-create-outline-function-alist*
        (stable-sort
         (nconc *outline-tree-create-outline-function-alist*
                (list (list func-symbol func-name func-type func-doc)))
         #'string< :key #'second)))
(defvar *outline-tree-create-outline-function-menu* nil)
(defun outline-tree-create-outline-function-menu-gen ()
  (let ((outline-type-alist '((:all      . "S(&A)")
                              (nil       . nil)
                              (:generic  . "ʉ(&G)")
                              (:language . "(&L)")
                              (:format   . "t@CtH[}bg(&F)")
                              (:misc     . "̑(&M)")
                              (:user     . "[U(&U)")))
        (outline-type-hash (make-hash-table))
        outline-type-symbol outline-type-name gen popup-menu)
    ;; V[gJbgWFl[^
    (setq gen (let (ccode)
                #'(lambda (&optional init)
                    (if init
                        (setq ccode nil)
                      (progn
                        (cond ((null ccode) (setq ccode (char-code #\A)))
                              ((and (>= ccode (char-code #\A))
                                    (< ccode (char-code #\Z))) (incf ccode))
                              ((= ccode (char-code #\Z)) (setq ccode (char-code #\0)))
                              ((< ccode (char-code #\9)) (incf ccode))
                              (t (setq ccode (char-code #\A))))
                        (code-char ccode))))))
    (setq *outline-tree-create-outline-function-menu*
          (create-popup-menu 'outline-tree-create-outline-function))
    ;; 쐬֐̕
    (dolist (x *outline-tree-create-outline-function-alist*)
      (setq x (copy-tree x))
      (let ((func-symbol (first x)) (func-name (second x)) (func-type (third x)))
        (cond ((member :user func-type)
               (push x (gethash :user outline-type-hash)))
              ((member :language func-type)
               (push x (gethash :language outline-type-hash)))
              ((member :generic func-type)
               (push x (gethash :generic outline-type-hash)))
              ((member :format func-type)
               (push x (gethash :format outline-type-hash)))
              (t
               (push x (gethash :misc outline-type-hash))))
        (push x (gethash :all outline-type-hash))))
    ;; j[쐬
    (dolist (outline-type outline-type-alist)
      (setq outline-type-symbol (car outline-type)
            outline-type-name (cdr outline-type))
      (cond
       ((eq outline-type-symbol nil)
        (add-menu-separator *outline-tree-create-outline-function-menu*))
       (t
        (funcall gen t)
        (setq popup-menu (create-popup-menu outline-type-symbol))
        (add-popup-menu *outline-tree-create-outline-function-menu*
                        popup-menu outline-type-name)
        (dolist (x (nreverse (gethash outline-type-symbol outline-type-hash)))
          (setq x (copy-tree x))
          (let ((func-symbol (first x)) (func-name (second x)) (func-type (third x)))
            (add-menu-item popup-menu
                           func-symbol
                           (concat func-name (format nil "(&~A)" (funcall gen)))
                           #'(lambda () (interactive)
                               (save-excursion
                                 (set-buffer (outline-tree-get-buffer-by-node))
                                 (setq outline-tree-create-outline-function-interactive func-symbol)
                                 (outline-tree-create-outline-by-node)
                                 (treeview::treeview-message "~A" func-name)))
                           #'(lambda ()
                               (cond
                                ((not (outline-tree-exist-p))
                                 :disable)
                                ((not (outline-tree-get-buffer-node-by-node))
                                 :disable)
                                ((eq (outline-tree-get-create-outline-function-by-node) func-symbol)
                                 :check)))))))))
    ;; app-menu j[̍XV
    (when (menup *outline-tree-app-menu*)
      (let ((pos (get-menu-position *outline-tree-app-menu*
                                    'outline-tree-create-outline-function)))
        (when pos
          (delete-menu *outline-tree-app-menu* 'outline-tree-create-outline-function)
          (insert-popup-menu *outline-tree-app-menu* pos
                             *outline-tree-create-outline-function-menu*
                             "AEgC^CvI(&S)"))))))

;;----------------------------------------------------------------------------
;; outline 쐬֐\@\
;;----------------------------------------------------------------------------
(defvar *outline-tree-create-outline-function-info-menu* nil)
(defun outline-tree-create-outline-function-info-menu-gen ()
  (let ((outline-type-alist '((:all      . "S(&A)")
                              (nil       . nil)
                              (:generic  . "ʉ(&G)")
                              (:language . "(&L)")
                              (:format   . "t@CtH[}bg(&F)")
                              (:misc     . "̑(&M)")
                              (:user     . "[U(&U)")))
        (outline-type-hash (make-hash-table))
        outline-type-symbol outline-type-name gen popup-menu)
    ;; V[gJbgWFl[^
    (setq gen (let (ccode)
                #'(lambda (&optional init)
                    (if init
                        (setq ccode nil)
                      (progn
                        (cond ((null ccode) (setq ccode (char-code #\A)))
                              ((and (>= ccode (char-code #\A))
                                    (< ccode (char-code #\Z))) (incf ccode))
                              ((= ccode (char-code #\Z)) (setq ccode (char-code #\0)))
                              ((< ccode (char-code #\9)) (incf ccode))
                              (t (setq ccode (char-code #\A))))
                        (code-char ccode))))))
    (setq *outline-tree-create-outline-function-info-menu*
          (create-popup-menu 'outline-tree-create-outline-function-info))
    ;; 쐬֐̕
    (dolist (x *outline-tree-create-outline-function-alist*)
      (setq x (copy-tree x))
      (let ((func-symbol (first x)) (func-name (second x)) (func-type (third x)))
        (cond ((member :user func-type)
               (push x (gethash :user outline-type-hash)))
              ((member :language func-type)
               (push x (gethash :language outline-type-hash)))
              ((member :generic func-type)
               (push x (gethash :generic outline-type-hash)))
              ((member :format func-type)
               (push x (gethash :format outline-type-hash)))
              (t
               (push x (gethash :misc outline-type-hash))))
        (push x (gethash :all outline-type-hash))))
    ;; j[쐬
    (add-menu-item *outline-tree-create-outline-function-info-menu* nil
                   "ꗗ(&0)"
                   #'(lambda () (interactive)
                       (with-output-to-temp-buffer ("*outline-tree: info*")
                         (dolist (outline-type outline-type-alist)
                           (setq outline-type-symbol (car outline-type)
                                 outline-type-name (cdr outline-type))
                           (when (member outline-type-symbol '(:all))
                             (setq outline-type-symbol nil
                                   outline-type-name nil))
                           (when outline-type-symbol
                             (string-match "^\\(.+\\)(.+)$" outline-type-name)
                             (format t "y~Az~%" (match-string 1)))
                           (dolist (x (reverse (gethash outline-type-symbol outline-type-hash)))
                             (setq x (copy-tree x))
                             (let ((func-symbol (first x)) (func-name (second x))
                                   (func-type (third x)) (func-doc (fourth x)))
                               (format t "~A~%" func-name)
                               (format t "~%~A~%~%" (or func-doc ""))
                               (format t "AUTO-MODE w~%  -*- outline-tree: ~A -*-~%~%"
                                       (let ((str (symbol-name func-symbol)))
                                         (when (string-matchp "^outline-tree2:+\\(.+\\)" str)
                                           (setq str (match-string 1)))
                                         (when (string-match "^outline-tree-create-outline-\\(.+\\)" str)
                                           (setq str (match-string 1)))
                                         str))
                               (format t "V{~%  ~S~%~%" func-symbol)
                               (format t "ށEt~%")
                               (if func-type
                                   (let* ((func-type-main (car func-type))
                                          (func-type-sub (cdr func-type))
                                          (func-type-main-name (cdr (find func-type-main outline-type-alist :key #'car))))
                                     (if func-type-main-name
                                         (progn
                                           (string-match "^\\(.+\\)(.+)$" func-type-main-name)
                                           (format t "  ~A~%" (or (match-string 1) func-type-main-name)))
                                       (format t "~%"))
                                     (dolist (x func-type-sub)
                                       (cond
                                        ((eq x :line-oriented)
                                         (format t "    - sw~%"))
                                        ((eq x :blank-line-oriented)
                                         (format t "    - sw~%"))
                                        ((eq x :sequential)
                                         (format t "    - V[PV~%"))
                                        (t
                                         (format t "~%")))))
                                 (format t "  Ȃ~%"))
                               (format t "~%")))))
                       (refresh-screen)))
    (add-menu-separator *outline-tree-create-outline-function-info-menu*)
    (dolist (outline-type outline-type-alist)
      (setq outline-type-symbol (car outline-type)
            outline-type-name (cdr outline-type))
      (cond
       ((eq outline-type-symbol nil)
        (add-menu-separator *outline-tree-create-outline-function-info-menu*))
       (t
        (funcall gen t)
        (setq popup-menu (create-popup-menu outline-type-symbol))
        (add-popup-menu *outline-tree-create-outline-function-info-menu*
                        popup-menu outline-type-name)
        (dolist (x (reverse (gethash outline-type-symbol outline-type-hash)))
          (setq x (copy-tree x))
          (let ((func-symbol (first x)) (func-name (second x)) (func-type (third x)) (func-doc (fourth x)))
            (add-menu-item popup-menu
                           func-symbol
                           (concat func-name (format nil "(&~A)" (funcall gen)))
                           #'(lambda () (interactive)
                               (with-output-to-temp-buffer ("*outline-tree: info*")
                                 (format t "~A~%" func-name)
                                 (format t "~%~A~%~%" (or func-doc ""))
                                 (format t "AUTO-MODE w~%  -*- outline-tree: ~A -*-~%~%"
                                         (let ((str (symbol-name func-symbol)))
                                           (when (string-matchp "^outline-tree2:+\\(.+\\)" str)
                                             (setq str (match-string 1)))
                                           (when (string-match "^outline-tree-create-outline-\\(.+\\)" str)
                                             (setq str (match-string 1)))
                                           str))
                                 (format t "V{~%  ~S~%~%" func-symbol)
                                 (format t "ށEt~%")
                                 (if func-type
                                     (let ((func-type-main (car func-type))
                                           (func-type-sub (cdr func-type)))
                                       (format t "  ~S" func-type-main)
                                       (if (find func-type-main outline-type-alist :key #'car)
                                           (format t "        : ~A~%~%"
                                                   (cdr (find func-type-main outline-type-alist :key #'car)))
                                         (format t "~%~%"))
                                       (dolist (x func-type-sub)
                                         (format t "  ~S" x)
                                         (cond
                                          ((eq x :line-oriented)
                                           (format t "    : sw~%"))
                                          ((eq x :blank-line-oriented)
                                           (format t "    : sw~%"))
                                          ((eq x :sequential)
                                           (format t "    : V[PV~%"))
                                          (t
                                           (format t "~%")))))
                                   (format t "  Ȃ~%"))
                                 (format t "~%"))
                               (refresh-screen))
                           #'(lambda ()
                               (and (eq (outline-tree-get-create-outline-function-by-node) func-symbol)
                                    :check))))))))
    ;; app-menu j[̍XV
    (when (menup *outline-tree-app-menu*)
      (let ((pos (get-menu-position *outline-tree-app-menu*
                                    'outline-tree-create-outline-function-info)))
        (when pos
          (delete-menu *outline-tree-app-menu* 'outline-tree-create-outline-function-info)
          (insert-popup-menu *outline-tree-app-menu* pos
                             *outline-tree-create-outline-function-info-menu*
                             "AEgC^Cv(&P)"))))))

;;----------------------------------------------------------------------------
;; m[hJ֐
;;----------------------------------------------------------------------------
(gc)
(require "outline-tree/expand")

;;----------------------------------------------------------------------------
;; outline 쐬֐
;;----------------------------------------------------------------------------
; oCgRpCς݂̏ꍇAx̃^C~O gc 
; ĂȂƁAoutline-tree.l [h access violation ƂȂB
(gc)
(require "outline-tree/cr-range-internal")
(require "outline-tree/cr-regexp-internal")
(require "outline-tree/cr-topic-internal")
(require "outline-tree/cr-hierarchy-internal")
(require "outline-tree/cr-regexp-inheritance")
(require "outline-tree/cr-hierarchy-inheritance")
(require "outline-tree/cr-topic")
(require "outline-tree/cr-regexp")
(require "outline-tree/cr-tag")
(require "outline-tree/cr-css")
(require "outline-tree/cr-hiki")
(require "outline-tree/cr-html-heading")
(require "outline-tree/cr-html-info-and-heading")
(require "outline-tree/cr-ini")
(require "outline-tree/cr-texinfo")
(require "outline-tree/cr-rd")
(require "outline-tree/cr-LaTeX")
(require "outline-tree/cr-lisp")
(require "outline-tree/cr-perl")
(require "outline-tree/cr-VB-like")
(require "outline-tree/cr-ASP")
(require "outline-tree/cr-XTAGS")
(require "outline-tree/cr-list-function")
(require "outline-tree/cr-grep")
(require "outline-tree/cr-2ch")
(require "outline-tree/cr-indent")
(require "outline-tree/cr-sted")
(require "outline-tree/cr-eMemoPad")
(require "outline-tree/cr-RFC")
(require "outline-tree/cr-blank-line")
(require "outline-tree/cr-xdoc2txt-pdf")
(require "outline-tree/cr-xdoc2txt-excel")
(require "outline-tree/get-outline-function")

;;----------------------------------------------------------------------------
;; outline 쐬֐̐֐
;;----------------------------------------------------------------------------
(gc)
(require "outline-tree/gen-cr-user-topic")
(require "outline-tree/gen-cr-user-regexp")

;;----------------------------------------------------------------------------
;; o͊֐
;;----------------------------------------------------------------------------
(gc)
(require "outline-tree/output")
(require "outline-tree/op-heading-html")
(require "outline-tree/op-heading-html-frame")
(require "outline-tree/op-range-html")
(require "outline-tree/op-range-html-frame")

;;----------------------------------------------------------------------------
;; c[o[/app-menu
;;----------------------------------------------------------------------------
(gc)
(require "outline-tree/toolbar")
(require "outline-tree/app-menu")

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; [eBeB
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun outline-tree-save-some-buffers (verbose buffers &optional (fn #'ed::write-file))
  (long-operation
    (let ((count 0))
      (save-excursion
        (dolist (buffer buffers)
          (when (need-buffer-save-p buffer)
            (set-buffer buffer)
            (if (not (file-visited-p))
                (progn
                  (refresh-screen)
                  (if (yes-no-or-cancel-p "~aZ[u܂?" buffer)
                      (when (call-interactively fn)
                        (setq count (1+ count)))
                    (not-modified)))
              (when (or (not verbose)
                        (progn
                          (refresh-screen)
                          (yes-no-or-cancel-p "~a~%Z[u܂?"
                                              (get-buffer-file-name))))
                (save-buffer)
                (setq count (1+ count)))))))
      (message "~d̃t@CZ[u܂" count))))

(defun outline-tree-kill-folder-file-buffers (folder &optional not-verbose)
  (let (file buffers)
    (dolist (buffer (buffer-list))
      (when (and (setq file (get-buffer-file-name buffer))
                 (path-equal folder (directory-namestring file)))
        (push buffer buffers)))
    (setq buffers (nreverse buffers))
    (outline-tree-save-some-buffers (not not-verbose) buffers)
    (prog1
        (dolist (buffer buffers t)
          (kill-buffer buffer))
      (winapi:InvalidateRect (get-window-handle) 0 1)
      (winapi:UpdateWindow (get-window-handle))
      (refresh-screen))))

(defun outline-tree-delete-category-buffers (category-node)
  (let (delete-buffer-p)
    (dolist (buffer (buffer-list))
      (when (and (eq category-node (outline-tree-get-category-node-by-buffer buffer))
                 (not (find (buffer-name buffer) *outline-tree-delete-category-buffers-except-regexp-list*
                            :test #'(lambda (buffer-name regexp) (string-match regexp buffer-name)))))
        (delete-buffer buffer)
        (setq delete-buffer-p t)))
    (when delete-buffer-p
      (winapi:InvalidateRect (get-window-handle) 0 1)
      (winapi:UpdateWindow (get-window-handle))
      (refresh-screen))))

(defun outline-tree-create-outline-and-select-node ()
  (interactive)
  (unless (outline-tree-latest-outline-p-by-window)
    (outline-tree-create-outline-by-window))
  (unless (outline-tree-open-p)
    (outline-tree-open))
  ;; AŃR}hsꂽꍇAm[h expand  toggle B
  (when (eq *last-command* 'outline-tree-create-outline-and-select-node)
    (treeview::with-app (*outline-tree-app-id*)
      (let ((node (outline-tree-get-selected-node)))
        (when (outline-tree-node-has-children-p node)
          (treeview::treeview-expand-toggle node)))))
  (outline-tree-select-node-by-window nil nil))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; xyzzy N
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun outline-tree-startup ()
  (outline-tree-initialize-treeview)
  (outline-tree-create-outline-function-menu-gen)
  (outline-tree-create-outline-function-info-menu-gen)
  (when (eq *outline-tree-use* t)
    ;; (outline-tree-create) ̂܂܎sƋN *app-menu* 
    ;; gbvxɒǉ郁j[ (ex. browserex) ɂ萳퓮
    ;; ȂȂB
    ;; ^C~O̖Ɏv邽߁Astart-timer ŉB
;   (outline-tree-create)
    (start-timer 0.01 #'outline-tree-create t))
  (run-hooks '*outline-tree-startup-hook*))

(if (menup ed::*app-menu*)
    (outline-tree-insert-menu-items :head-sep t)
  (add-hook 'ed::*init-app-menus-hook*
            #'(lambda () (outline-tree-insert-menu-items :head-sep t))))

(add-hook 'ed::*post-startup-hook* 'outline-tree-startup)

;;; outline-tree.l ends here
