;;; -*- Mode: Lisp; Package: OUTLINE-TREE2 -*-
;;; defs.l --- outline-tree

;; Copyright (C) 2001-2006 OHKUBO Hiroshi <ohkubo@s53.xrea.com>

;; Author: OHKUBO Hiroshi <ohkubo@s53.xrea.com>
;; Time-stamp: <2006/10/25 02:27:34 +0900>

;;; Code:

(provide "outline-tree/defs")

(eval-when (:compile-toplevel :load-toplevel :execute)
  (unless (find-package "outline-tree2")
    (defpackage "outline-tree2"
      (:use "lisp" "editor"))))

(in-package "outline-tree2")

;;----------------------------------------------------------------------------
;; {
;;----------------------------------------------------------------------------
(defconstant *outline-tree-version* "2006.10.25")
(defvar *outline-tree-debug* nil)

;;----------------------------------------------------------------------------
;; pX
;;----------------------------------------------------------------------------
;; config t@C / autoload fBNg
(defvar *outline-tree-base-directory* "~/.outline-tree")
(defvar *outline-tree-config-file*
  (merge-pathnames "config.l" *outline-tree-base-directory*))
(defvar *outline-tree-autoload-directory*
  (merge-pathnames "autoload" *outline-tree-base-directory*))

;;----------------------------------------------------------------------------
;; HOOK
;;----------------------------------------------------------------------------
;; TREEVIEW 쐬/폜/ACXg[
(defvar *outline-tree-create-hook* nil
  "outline-tree Jnɕ]B
outline-tree-create ̍Ō run-hooks ŏB")
(defvar *outline-tree-delete-hook* nil
  "outline-tree Iɕ]B
outline-tree-delete ̍Ō run-hooks ŏB")

(defvar *outline-tree-startup-hook* nil
  "outline-tree Nɕ]B
outline-tree-startup ̍Ō run-hooks ŏB")
(defvar *outline-tree-uninstall-hook* nil
  "outline-tree ACXg[ɕ]B
outline-tree-uninstall ̃qXgϐ폜O run-hooks ŏB")

;; obt@m[h̍폜
(defvar *outline-tree-delete-buffer-node-hook* nil
  "buffer-node 폜ɕ]B
outline-tree-delete-buffer-node-by-buffer ̍Ō buffer Ƃ
run-hook-with-args ŏB")

;; AEgC̍쐬
(defvar *outline-tree-create-outline-hook* nil
  "obt@̃AEgC쐬ɕ]B
outline-tree-create-outline-by-buffer ̍Ō run-hooks ŏB
outline-tree-create-outline-by-buffer ֐ɂ̓obt@̃XgnƂ
\Aobt@̃XgnꍇAobt@ł͂Ȃx̂ݕ]
B")

;;----------------------------------------------------------------------------
;; 
;;----------------------------------------------------------------------------
;; wb_m[h
(defvar *outline-tree-header-node-name* "<HEADER>"
  "wb_m[hB
outline-tree-create-outline-regexp-internal,
outline-tree-create-outline-topic-internal ֐ɂĕ]B")

;; JeSm[h
(defvar *outline-tree-visible-buffer-category-node-name* "=== \obt@ ==="
  "\obt@pJeSm[h")
(defvar *outline-tree-invisible-buffer-category-node-name* "=== \obt@ ==="
  "\obt@pJeSm[h")

;; TuJeSo
(defvar *outline-tree-buffer-category-regexp-list*
  '(("^ *\\(\\*Minibuf\\)"      . " Minibuf")
    ("^ *\\(\\*howm\\)"         . " howm")
    ("^ *\\(\\*Help\\*\\)"      . " Help")
    ("^ *\\(\\*NetInstaller\\)" . " NetInstaller")
    ("^ *\\(\\*RSS\\)"          . " RSS")
    "^ *\\*?\\(.+?\\):"
    ("^\\*untitled\\*"          . " *untitled*"))
  "obt@JeS肷ۂɗpB
outline-tree-detect-category-name ֐ŎgpB")

;; m[hΉeLXgnCCg
(defvar *outline-tree-text-highlight-attribute*
  '(:background 3 :prefix #\T :extend t)
  "m[hΉeLXgnCCgƂ̕\B
outline-tree-set-text-highlight ŏB")

;;
(defvar *outline-tree-delete-category-buffers-except-regexp-list*
  '("^\\*scratch\\*$")
  "uJeSvۂɑΏۊOobt@̐K\XgɎw肷B
outline-tree-delete-category-buffers ֐ŎgpB")

;;----------------------------------------------------------------------------
;; app-menu
;;----------------------------------------------------------------------------
(defvar *outline-tree-app-menu* nil
  "outline-tree j[")
(defvar *outline-tree-app-menu-position* 'ed::help
  "outline-tree j[ʒu")
(define-history-variable *outline-tree-app-menu-name* "&Outline-Tree"
  "outline-tree j[")
(define-history-variable *outline-tree-set-app-menu* t
  "outline-tree j[NԂL^邽߂̃tO")

;;; defs.l ends here
