;;; -*- Mode: Lisp; Package: OUTLINE-TREE2 -*-
;;; toolbar.l --- outline-tree

;; Copyright (C) 2001-2005 OHKUBO Hiroshi <ohkubo@s53.xrea.com>

;; Author: OHKUBO Hiroshi <ohkubo@s53.xrea.com>
;; Time-stamp: <2005/12/26 19:40:36 +0900>

;;; Code:

(provide "outline-tree/toolbar")

(require "outline-tree/defs")
(require "treeview/virtual-keys")

(in-package "outline-tree2")

(defun outline-tree-tool-bar-toggle-open-close ()
  (interactive)
  "AEgCc[JB
N  FNAI[v
N[YFI[v
I[vFN[YBCtrl ĂꍇI"
  (let ((ctrl (or (minusp (winapi:GetKeyState winapi:VK_CONTROL))
                  (minusp (winapi:GetKeyState winapi:VK_LCONTROL))
                  (minusp (winapi:GetKeyState winapi:VK_RCONTROL)))))
    (cond
     ((not (outline-tree-exist-p))
      (outline-tree-create)
      (outline-tree-open))
     ((outline-tree-open-p)
      (if ctrl
          (outline-tree-delete)
        (outline-tree-close)))
     (t
      (outline-tree-open)))))

(defun outline-tree-tool-bar ()
  (create-tool-bar
   'outline-tree-tool-bar
   (merge-pathnames "etc/toolbar-outline-tree.bmp" (si:system-root))
   `(("AEgCc[" 0 outline-tree-tool-bar-toggle-open-close
      ,#'(lambda () (and (outline-tree-open-p) :check))))))

(define-command-bar 'outline-tree-tool-bar "AEgCc[(&O)")

(add-hook '*outline-tree-uninstall-hook*
          #'(lambda () (delete-command-bar 'outline-tree-tool-bar)))

;;; toolbar.l ends here
